#pragma once

#include "config.h"
#include "../resource.h"

//====================================
// AISH̐ݒ荀
//====================================
class CConfigAISH : public CDialogImpl<CConfigAISH>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	CButton			Radio_EncodeType[ISH_ENCODE_TYPE_MAX_NUM];
	CButton			Check_UUEncodeChecksum;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_AISH };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigAISH)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();

	CConfigAISH(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE("CConfigAISH()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

