#pragma once

#include "config.h"
#include "../resource.h"
#include <atlddx.h>		// DDX/DDVgp邽

//====================================
// B2E̐ݒ荀
//====================================
class CConfigB2E : public CDialogImpl<CConfigB2E>,public CWinDataExchange<CConfigB2E>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	CButton Check_EnableB2E;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_B2E };

	// DDX}bv
	BEGIN_DDX_MAP(CConfigB2E)
		DDX_TEXT(IDC_EDIT_B2E_SCRIPT_DIRECTORY, Config.B2E.ScriptDirectory)
		DDX_TEXT(IDC_EDIT_B2E_PRIORITY_EXTENSION, Config.B2E.Extensions)
		DDX_CHECK(IDC_CHECK_PRIORITIZE_B2E,Config.B2E.Priority)
		DDX_CHECK(IDC_CHECK_ENABLE_B2E_MENU,Config.B2E.EnableShellMenu)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigB2E)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_BUTTON_BROWSE_B2E,OnBrowse)
		COMMAND_ID_HANDLER(IDC_CHECK_ENABLE_B2E,OnCheckEnable)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	LRESULT OnBrowse(WORD,WORD,HWND,BOOL&);

	CConfigB2E(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE("CConfigB2E()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
	LRESULT OnCheckEnable(WORD,WORD,HWND,BOOL&);
};

