#include "common.h"
#include "config_compress_general.h"


//==================
// kʐݒ
//==================
LRESULT CConfigCompressGeneral::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//------------------
	// ko͐^Cv
	//------------------
	Radio_CompressTo[COMPRESS_TO_DESKTOP]=GetDlgItem(IDC_RADIO_COMPRESS_TO_DESKTOP);
	Radio_CompressTo[COMPRESS_TO_SAME_DIR]=GetDlgItem(IDC_RADIO_COMPRESS_TO_SAME_DIR);
	Radio_CompressTo[COMPRESS_TO_SPECIFIC_DIR]=GetDlgItem(IDC_RADIO_COMPRESS_TO_SPECIFIC_DIR);
	Radio_CompressTo[COMPRESS_TO_ALWAYS_ASK_WHERE]=GetDlgItem(IDC_RADIO_COMPRESS_TO_ALWAYS_ASK_WHERE);

	Radio_CompressTo[Config.Common.Compress.OutputDirType].SetCheck(1);

	//----------------------------------------------------
	// o͐tH_̃pXGfBbgRg[ɐݒ
	//----------------------------------------------------
	Edit_CompressOutputDirPath=GetDlgItem(IDC_EDIT_COMPRESS_TO_SPECIFIC_DIR);
	Edit_CompressOutputDirPath.SetLimitText(_MAX_PATH);
	Edit_CompressOutputDirPath.SetWindowText(Config.Common.Compress.OutputDir);

	Button_CompressToFolder=GetDlgItem(IDC_BUTTON_COMPRESS_BROWSE_FOLDER);

	//o͐w肷邽߂̃{^ƃGfBbgRg[̗L؂ւ
	bool bActive=COMPRESS_TO_SPECIFIC_DIR==Config.Common.Compress.OutputDirType;
	Edit_CompressOutputDirPath.EnableWindow(bActive);
	Button_CompressToFolder.EnableWindow(bActive);

	//--------------------------------
	// Ɉkt@C̏
	//--------------------------------
	UpDown_MaxCompressFileCount=GetDlgItem(IDC_SPIN_MAX_COMPRESS_FILECOUNT);

	UpDown_MaxCompressFileCount.SetPos(Config.Common.Compress.MaxCompressFileCount);
	UpDown_MaxCompressFileCount.SetRange(1,32767);

	UpDown_MaxCompressFileCount.EnableWindow(Config.Common.Compress.LimitCompressFileCount);
	::EnableWindow(GetDlgItem(IDC_EDIT_MAX_COMPRESS_FILECOUNT),Config.Common.Compress.LimitCompressFileCount);

	//uɈkt@C𐧌v`FbN{bNX
	Check_LimitCompressFileCount=GetDlgItem(IDC_CHECK_LIMIT_COMPRESS_FILECOUNT);


	//DDXݒ
	DoDataExchange(FALSE);

	return TRUE;
}

LRESULT CConfigCompressGeneral::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//------------------
	// ko͐^Cv
	//------------------
	for(int Type=0;Type<COMPRESS_TO_MAX_NUM;Type++){
		if(Radio_CompressTo[Type].GetCheck()){
			Config.Common.Compress.OutputDirType=(COMPRESS_TO)Type;
			break;
		}
	}
	//----------------------
	// o͐tH_̃pX
	//----------------------
	Edit_CompressOutputDirPath.GetWindowText(Config.Common.Compress.OutputDir,_MAX_PATH);

	//--------------------------------
	// Ɉkt@C̏
	//--------------------------------
	Config.Common.Compress.MaxCompressFileCount=UpDown_MaxCompressFileCount.GetPos();

	//---------------
	// DDXf[^擾
	//---------------
	if(!DoDataExchange(TRUE)){
		return FALSE;
	}

	//------------------------------------------------
	// t@Ci[ĂtH_Jǂ
	//-------------------------------------------------
//	Config.Common.Compress.OpenDir=Check_OpenDirAfterCompress.GetCheck();
	return TRUE;
}

LRESULT CConfigCompressGeneral::OnRadioCompressTo(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		bool bActive=(0!=Radio_CompressTo[COMPRESS_TO_SPECIFIC_DIR].GetCheck());
		Edit_CompressOutputDirPath.EnableWindow(bActive);
		Button_CompressToFolder.EnableWindow(bActive);
	}
	return 0;
}

LRESULT CConfigCompressGeneral::OnBrowseFolder(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		TCHAR FolderPath[_MAX_PATH+1];
		FILL_ZERO(FolderPath);

		Edit_CompressOutputDirPath.GetWindowText(FolderPath,_MAX_PATH);

		CString title(MAKEINTRESOURCE(IDS_INPUT_TARGET_FOLDER));
		CFolderDialog dlg(m_hWnd,title,BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE);
		dlg.SetInitialFolder(FolderPath);
		if(IDOK==dlg.DoModal()){
			_tcsncpy(FolderPath,dlg.GetFolderPath(),_MAX_PATH);
			Edit_CompressOutputDirPath.SetWindowText(FolderPath);
		}
	}
	return 0;
}

LRESULT CConfigCompressGeneral::OnCheckLimitCompressFileCount(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		BOOL State=Check_LimitCompressFileCount.GetCheck();
		UpDown_MaxCompressFileCount.EnableWindow(State);
		::EnableWindow(GetDlgItem(IDC_EDIT_MAX_COMPRESS_FILECOUNT),State);
	}
	return 0;
}

