#include "common.h"
#include "config_dll_update.h"
//#include "../const.h"

//=====================
// DLLAbvf[g
//=====================
LRESULT CConfigDLLUpdate::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//------------------
	// Abvf[g֌W
	//------------------
	Check_AskUpdate=GetDlgItem(IDC_CHECK_DLL_ASK_UPDATE);
	Check_AskUpdate.SetCheck(Config.Update.AskUpdate);

	UpDown_Interval=GetDlgItem(IDC_SPIN_DLL_UPDATE_INTERVAL);
	UpDown_Interval.SetPos(Config.Update.Interval);
	UpDown_Interval.SetRange(1,365);

	BOOL State=Check_AskUpdate.GetCheck();
	UpDown_Interval.EnableWindow(State);
	::EnableWindow(GetDlgItem(IDC_EDIT_DLL_UPDATE_INTERVAL),State);

	//-------------------
	// DLLo[W
	//-------------------
	List_DLLVersion=GetDlgItem(IDC_LIST_DLL_VERSION);

	//Xgr[ɃJǉ
	CRect rect;
	List_DLLVersion.GetClientRect(rect);
	int nScrollWidth = GetSystemMetrics(SM_CXVSCROLL);
	List_DLLVersion.InsertColumn(0, CString(MAKEINTRESOURCE(IDS_DLL_INFO_NAME)), LVCFMT_LEFT, 80, -1);
	List_DLLVersion.InsertColumn(1, CString(MAKEINTRESOURCE(IDS_DLL_INFO_VERSION)), LVCFMT_LEFT,rect.Width() - 80 - nScrollWidth, -1);

	//eDLL̏ǉ
	for(int i=0;i<DLL_ID_MAX_NUM;i++){
		CArchiverDLL *Archiver=ArchiverManager.GetArchiver((DLL_ID)i,true,true);
		ASSERT(Archiver);
		List_DLLVersion.AddItem(i, 0, Archiver->GetName());
		if(!Archiver->IsOK()){
			List_DLLVersion.AddItem(i, 1,CString(MAKEINTRESOURCE(IDS_MESSAGE_DLL_NOT_AVAILABLE)));
		}
		else{
			CString vs;
			Archiver->GetVersionString(vs);
			List_DLLVersion.AddItem(i,1,vs);
		}
	}
	//DLLJ
	ArchiverManager.Free();

	return TRUE;
}

LRESULT CConfigDLLUpdate::OnDLLUpdate(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		//--------------------
		// LFCaldix̃pX擾
		//--------------------
		TCHAR ExePath[_MAX_PATH+1];
		FILL_ZERO(ExePath);
		GetModuleFileName(GetModuleHandle(NULL), ExePath, _MAX_PATH);

		PathRemoveFileSpec(ExePath);
		PathAppend(ExePath,CString(MAKEINTRESOURCE(IDS_CALDIX_EXE_NAME)));
		if(32>=(int)ShellExecute(m_hWnd,NULL,ExePath,NULL,NULL,SW_RESTORE)){
			//sG[
			LPVOID lpMsgBuf;
			FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,NULL,GetLastError(),MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),(LPTSTR)&lpMsgBuf, 0, NULL);

			CString msg;
			msg.Format(IDS_ERROR_CANNOT_EXECUTE,ExePath,lpMsgBuf);
			LocalFree(lpMsgBuf);

			ErrorMessage(msg);
		}
	}
	return 0;
}

LRESULT CConfigDLLUpdate::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	Config.Update.AskUpdate=Check_AskUpdate.GetCheck();

	Config.Update.Interval=UpDown_Interval.GetPos();

	return TRUE;
}

LRESULT CConfigDLLUpdate::OnCheckAskUpdate(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		BOOL State=Check_AskUpdate.GetCheck();
		UpDown_Interval.EnableWindow(State);
		::EnableWindow(GetDlgItem(IDC_EDIT_DLL_UPDATE_INTERVAL),State);
	}
	return 0;
}
