#pragma once
#include "config.h"
#include "../util.h"
#include "../resource.h"
#include "../ArchiverManager.h"

//====================================
// DLL̏ƍXV
//====================================
class CConfigDLLUpdate : public CDialogImpl<CConfigDLLUpdate>,public CMessageFilter
{
protected:
	CConfigManager		&Config;
	CButton				Check_AskUpdate;
	CUpDownCtrl			UpDown_Interval;
	CListViewCtrl		List_DLLVersion;
	CArchiverDLLManager	&ArchiverManager;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_DLL_UPDATER };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDLLUpdate)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_BUTTON_DLL_UPDATE,OnDLLUpdate)
		COMMAND_ID_HANDLER(IDC_CHECK_DLL_ASK_UPDATE,OnCheckAskUpdate)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnDLLUpdate(WORD,WORD,HWND,BOOL&);
	LRESULT OnCheckAskUpdate(WORD,WORD,HWND,BOOL&);
	LRESULT OnApply();

	CConfigDLLUpdate(CConfigManager &cfg):
	Config(cfg),ArchiverManager(CArchiverDLLManager::GetInstance())
	{
		TRACE("CConfigDLLUpdate()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

