#pragma once

#include "config.h"
#include "../resource.h"

//====================================
// HKI̐ݒ荀
//====================================
class CConfigHKI : public CDialogImpl<CConfigHKI>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	CButton			Radio_CompressLevel[HKI_COMPRESS_LEVEL_MAX_NUM];
	CButton			Radio_EncryptAlgorithm[HKI_ENCRYPT_ALGORITHM_MAX_NUM];

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_HKI };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigHKI)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();

	CConfigHKI(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE("CConfigHKI()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

