#pragma once
#include "../common.h"
#include "../util.h"
#include "../resource.h"
#include "config.h"
#include "config_version.h"
#include "config_general.h"
#include "config_compress_general.h"
#include "config_extract_general.h"
#include "config_lzh.h"
#include "config_zip.h"
#include "config_cab.h"
#include "config_7z.h"
#include "config_tar.h"
#include "config_jack.h"
//#include "config_bh.h"
//#include "config_yz1.h"
#include "config_hki.h"
#include "config_bga.h"
#include "config_aish.h"
#include "config_xacrett.h"
#include "config_b2e.h"
#include "config_dll_update.h"
#include "config_assoc.h"
#include "config_detail.h"
#include "config_shortcut.h"
#include "config_filelistwindow.h"
#include "config_openaction.h"
#include "config_shellext.h"
#include <atlscrl.h>

#define WM_USER_WM_SIZE		(WM_APP+1)	//WM_SIZEAPostMessage;_CAOTCỸgbN̂

//====================================
// ݒ荀ڂ܂Ƃ߂
//====================================
class CConfigDialog : public CDialogImpl<CConfigDialog>,public CDialogResize<CConfigDialog>
{
protected:
	CConfigGeneral				PageGeneral;
	CConfigShellExt				PageShellExt;
	CConfigVersion				PageVersion;
	CConfigCompressGeneral		PageCompressGeneral;
	CConfigExtractGeneral		PageExtractGeneral;
	CConfigLZH					PageLZH;
	CConfigZIP					PageZIP;
	CConfigCAB					PageCAB;
	CConfig7Z					Page7Z;
	CConfigTAR					PageTAR;
	CConfigJACK					PageJACK;
//	CConfigBH					PageBH;
//	CConfigYZ1					PageYZ1;
	CConfigHKI					PageHKI;
	CConfigBGA					PageBGA;
	CConfigAISH					PageAISH;
	CConfigXACRETT				PageXACRETT;
	CConfigB2E					PageB2E;
	CConfigDLLUpdate			PageDLLUpdate;
	CConfigAssociationPage		PageAssociation;
	CConfigOpenAction			PageOpenAction;
//	CConfigAssociationPage2		PageAssociation2;
	CConfigDetail				PageDetail;
	CConfigShortcut				PageShortcut;
	CConfigFileListWindow		PageFileListWindow;

	HWND						hActiveDialogWnd;	//ANeBuȃ_CAO
	CTreeViewCtrl				SelectTreeView;

	//_CAO\t邽߂̃XN[Rei
	CScrollContainer			ScrollWindow;

	CConfigManager				&Config;
public:
	enum{IDD = IDD_DIALOG_CONFIG};

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		NOTIFY_CODE_HANDLER_EX(TVN_SELCHANGED, OnTreeSelect)
		COMMAND_ID_HANDLER_EX(IDOK, OnOK)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
		MSG_WM_SIZE(OnSize)
		CHAIN_MSG_MAP(CDialogResize<CConfigDialog>)
		MESSAGE_HANDLER(WM_USER_WM_SIZE,OnUserSize)
	END_MSG_MAP()

	// _CAOTCY}bv
	BEGIN_DLGRESIZE_MAP(CConfigDialog)
		DLGRESIZE_CONTROL(IDC_TREE_SELECT_PROPPAGE,			DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDC_STATIC_FRAME,					DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDOK,								DLSZ_MOVE_X | DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDCANCEL,							DLSZ_MOVE_X | DLSZ_MOVE_Y)
	END_DLGRESIZE_MAP()

	CConfigDialog(CConfigManager &cfg);

	LRESULT OnTreeSelect(LPNMHDR pnmh);
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	void OnSize(UINT, CSize&);
	LRESULT OnUserSize(UINT, WPARAM wParam, LPARAM, BOOL& bHandled);

	void OnOK(UINT uNotifyCode, int nID, HWND hWndCtl);
	void OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl);
};

