#include "common.h"
#include "FileListFrame.h"
#include "WaitDialog.h"
#include "../ConfigCode/configwnd.h"
#include <stack>
#include "ExtractEx.h"
#include "../LFFolderDialog.h"
#include "../Extract.h"	//Extract()

//t@Cꗗ̍쐬ɂ鎞Ԃ𒲂ׂƂɂ́AdefineLɂ
//#define __TIMETEST__

CFileListFrame::CFileListFrame(CConfigManager &conf,LPCTSTR ps,DLL_ID forceid):
	Config(conf),
	strPropString(ps),
	m_lpArchiver(NULL),
	m_idForceDLL(forceid),
	m_TempDirManager(_T("lhaf")),
	DnD(m_TempDirManager),
	m_bExtractEach(false)
{
}


BOOL CFileListFrame::PreTranslateMessage(MSG* pMsg)
{
	if(CFrameWindowImpl<CFileListFrame>::PreTranslateMessage(pMsg)){
		return TRUE;
	}
	return FileTreeView.PreTranslateMessage(pMsg);
}

LRESULT CFileListFrame::OnCreate(LPCREATESTRUCT lpcs)
{
	m_bFirst=true;
	Config.LoadConfig(CONFIG_FILELISTWINDOW);
	Config.LoadConfig(CONFIG_XACRETT);
	Config.LoadConfig(CONFIG_B2E);
	Config.LoadConfig(CONFIG_COMMON);
//========================================
//      t[EBhȄ
//========================================
	//EBhEvpeB̐ݒ(t@C̓{h~p)
	SetProp(m_hWnd,strPropString,m_hWnd);

	//EBhẼTCY̐ݒ
	if(Config.FileListWindow.StoreSetting){
		if(Config.FileListWindow.StoreWindowPosition){	//EBhEʒu𕜌ꍇ
			MoveWindow(Config.FileListWindow.WindowPos_x,Config.FileListWindow.WindowPos_y,Config.FileListWindow.Width,Config.FileListWindow.Height);
		}
		else{
			CRect Rect;
			GetWindowRect(Rect);
			MoveWindow(Rect.left,Rect.top,Config.FileListWindow.Width,Config.FileListWindow.Height);
		}
	}
	else if(Config.FileListWindow.StoreWindowPosition){	//EBhEʒuꍇ
		CRect Rect;
		GetWindowRect(Rect);
		MoveWindow(Config.FileListWindow.WindowPos_x,Config.FileListWindow.WindowPos_y,Rect.Width(),Rect.Height());
	}
	//EBhETCY擾
	GetWindowRect(m_WindowRect);

	// 傫ACRݒ
	HICON hIcon = AtlLoadIconImage(IDI_APP, LR_DEFAULTCOLOR,::GetSystemMetrics(SM_CXICON),::GetSystemMetrics(SM_CYICON));
	SetIcon(hIcon, TRUE);
	// ACRݒ
	HICON hIconSmall = AtlLoadIconImage(IDI_APP, LR_DEFAULTCOLOR,::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON));
	SetIcon(hIconSmall, FALSE);

	// o[쐬
	CreateSimpleReBar(ATL_SIMPLE_REBAR_NOBORDER_STYLE);
	// c[o[쐬ăohɒǉ
	HWND hWndToolBar=CreateSimpleToolBarCtrl(m_hWnd,IDR_MAINFRAME, FALSE, ATL_SIMPLE_TOOLBAR_PANE_STYLE);
	AddSimpleReBarBand(hWndToolBar);
	UIAddToolBar(hWndToolBar);
	SizeSimpleReBarBands();

	// Xe[^Xo[쐬
	m_hWndStatusBar=StatusBar.Create(m_hWnd);
	UIAddStatusBar(m_hWndStatusBar);
	int nPanes[] = {ID_DEFAULT_PANE, IDS_PANE_ITEMCOUNT_INITIAL,IDS_PANE_DLL_NAME_INITIAL};
	StatusBar.SetPanes(nPanes, sizeof(nPanes)/sizeof(nPanes[0]));
	{
		CString Text;
		Text.Format(IDS_PANE_ITEMCOUNT,0,0);
		StatusBar.SetPaneText(IDS_PANE_ITEMCOUNT_INITIAL,Text);
	}

	// Xvb^EBhE쐬
	SplitterWindow.Create(m_hWnd,rcDefault,NULL,WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS);

	// Xvb^EBhEgX^Cݒ
	SplitterWindow.SetSplitterExtendedStyle(0);

//========================================
//      Xgr[̏
//========================================
	// t@CꗗEBhE쐬
	// zXgr[쐬
	FileListView.Create(SplitterWindow,rcDefault,NULL,WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | LVS_OWNERDATA|LVS_AUTOARRANGE|LVS_SHAREIMAGELISTS|LVS_SHOWSELALWAYS, WS_EX_CLIENTEDGE);
	SplitterWindow.SetSplitterPane(SPLIT_PANE_RIGHT,FileListView);

	// C[WXg쐬
	m_ShellDataManager.Init();
	FileListView.SetImageList(m_ShellDataManager.GetImageList(true),LVSIL_NORMAL);
	FileListView.SetImageList(m_ShellDataManager.GetImageList(false),LVSIL_SMALL);

	//X^Cݒ
	FileListView.SetExtendedListViewStyle(LVS_EX_INFOTIP | LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES|LVS_EX_HEADERDRAGDROP);

	//\[gݒ
	if(Config.FileListWindow.StoreSetting){
		bSortDescending=(0!=Config.FileListWindow.SortDescending);
		SortColumn=Config.FileListWindow.SortColumn;
	}
	else{
		bSortDescending=true;
		SortColumn=-1;
	}

	//Xgr[X^CIpj[o[̃WI`FbNLɂ
	{
		CMenuHandle menuView = GetMenu();
		CMenuItemInfo mii;
		mii.fMask = MIIM_FTYPE;
		mii.fType = MFT_RADIOCHECK;
		menuView.SetMenuItemInfo(ID_MENUITEM_LISTVIEW_SMALLICON, FALSE, &mii);
		menuView.SetMenuItemInfo(ID_MENUITEM_LISTVIEW_LARGEICON, FALSE, &mii);
		menuView.SetMenuItemInfo(ID_MENUITEM_LISTVIEW_REPORT, FALSE, &mii);
		menuView.SetMenuItemInfo(ID_MENUITEM_LISTVIEW_LIST, FALSE, &mii);

		menuView.SetMenuItemInfo(ID_MENUITEM_LISTMODE_TREE, FALSE, &mii);
		menuView.SetMenuItemInfo(ID_MENUITEM_LISTMODE_FLAT, FALSE, &mii);
		menuView.SetMenuItemInfo(ID_MENUITEM_LISTMODE_FLAT_FILESONLY, FALSE, &mii);
	}

	//Xgr[X^C̐ݒ
	if(Config.FileListWindow.StoreSetting){
		DWORD Style=FileListView.GetWindowLong(GWL_STYLE);
		Style&=~(LVS_ICON|LVS_REPORT|LVS_SMALLICON|LVS_LIST);
		FileListView.SetWindowLong(GWL_STYLE,Style|Config.FileListWindow.ListStyle);

		//݂̕\ݒ̃j[Ƀ`FbNt
		switch(Config.FileListWindow.ListStyle){
		case LVS_SMALLICON:
			UISetCheck(ID_MENUITEM_LISTVIEW_SMALLICON, TRUE);
			break;
		case LVS_ICON:
			UISetCheck(ID_MENUITEM_LISTVIEW_LARGEICON, TRUE);
			break;
		case LVS_LIST:
			UISetCheck(ID_MENUITEM_LISTVIEW_LIST, TRUE);
			break;
		case LVS_REPORT:
			UISetCheck(ID_MENUITEM_LISTVIEW_REPORT, TRUE);
			break;
		default:
			ASSERT(!"Error");
			break;
		}
		//݂̕\[hɃ`FbN
		switch(Config.FileListWindow.FileListMode){
		case FILELIST_TREE:
			UISetCheck(ID_MENUITEM_LISTMODE_TREE, TRUE);
			break;
		case FILELIST_FLAT:
			UISetCheck(ID_MENUITEM_LISTMODE_FLAT, TRUE);
			break;
		case FILELIST_FLAT_FILESONLY:
			UISetCheck(ID_MENUITEM_LISTMODE_FLAT_FILESONLY, TRUE);
			break;
		default:
			ASSERT(!"Error");
			break;
		}
	}
	else{
		DWORD Style=FileListView.GetWindowLong(GWL_STYLE);
		Style&=~(LVS_ICON|LVS_REPORT|LVS_SMALLICON|LVS_LIST);
		FileListView.SetWindowLong(GWL_STYLE,Style|LVS_ICON);

		UISetCheck(ID_MENUITEM_LISTVIEW_LARGEICON, TRUE);
		UISetCheck(ID_MENUITEM_LISTMODE_TREE, TRUE);
	}

//========================================
//      c[r[쐬
//========================================
	FileTreeView.Create(SplitterWindow,rcDefault,NULL,WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN|TVS_HASBUTTONS | TVS_HASLINES | TVS_LINESATROOT | TVS_SHOWSELALWAYS,WS_EX_CLIENTEDGE);
	SplitterWindow.SetSplitterPane(SPLIT_PANE_LEFT, FileTreeView);

	m_hWndClient = SplitterWindow;
	UpdateLayout();

//========================================
//      EBhEʒu̐ݒ
//========================================
	// o[̈ʒuݒ
	SplitterWindow.SetSplitterPos(Config.FileListWindow.TreeWidth);

//========================================
//      Xgr[ɃJǉ
//========================================
	if(!SetListViewColumn())return -1;

//========================================
//      bZ[Wnh̐ݒ
//========================================
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);

//====================================
// c[r[ɃtH[JX
//====================================
	FileTreeView.SetFocus();

	//--------------------------------------------
	// t@CIĂȂƖȃj[
	//--------------------------------------------
	//uIt@C𓀁v𖳌
	UIEnable(ID_MENUITEM_EXTRACT_SELECTED,false);
	//uIt@C폜v𖳌
	UIEnable(ID_MENUITEM_DELETE_SELECTED,false);
	//uA[JCutH_ɉ𓀁v𖳌
	UIEnable(ID_MENUITEM_EXTRACT_SELECTED_SAMEDIR,false);
	//u֘AtŊJv𖳌
	UIEnable(ID_MENUITEM_OPEN_ASSOCIATION,false);
	//u㏑𓀂ĊJv𖳌
	UIEnable(ID_MENUITEM_OPEN_ASSOCIATION_OVERWRITE,false);
	//uꎞtH_ɉ𓀁v𖳌
	UIEnable(ID_MENUITEM_EXTRACT_TEMPORARY,false);


//======================================
// [U[wvOj[̏
//======================================
	m_MenuCommandArray=Config.FileListWindow.MenuCommandArray;

//==============================
// EBhEANeBuɂ
//==============================
//	SetForegroundWindow(m_hWnd);
	UtilSetAbsoluteForegroundWindow(m_hWnd);

	return 0;
}


bool CFileListFrame::SetListViewColumn()
{
//========================================
//      Xgr[ɃJǉ
//========================================
//Xgr[ɃJǉ邽߂̃}N
#define ADD_COLUMNITEM(x,width,pos) \
{if(-1!=UtilCheckNumberArray(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_##x)){\
	int nIndex=FileListView.InsertColumn(FILEINFO_##x, CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_##x)), pos, width,-1);\
	if(nIndex<0||nIndex>=FILEINFO_MAX_NUM)return false;\
	m_ColumnIndexArray[nIndex]=FILEINFO_##x;\
}}

	memset(m_ColumnIndexArray,-1,sizeof(int)*FILEINFO_MAX_NUM);

	//t@C
	ADD_COLUMNITEM(FILENAME,100,LVCFMT_LEFT);
	//tpX
	ADD_COLUMNITEM(FULLPATH,200,LVCFMT_LEFT);
	//t@CTCY
	ADD_COLUMNITEM(ORIGINALSIZE,90,LVCFMT_LEFT);
	//t@C
	ADD_COLUMNITEM(TYPENAME,120,LVCFMT_LEFT);
	//XV
	ADD_COLUMNITEM(FILETIME,120,LVCFMT_LEFT);
	//
	ADD_COLUMNITEM(ATTRIBUTE,60,LVCFMT_LEFT);
	//kTCY
	ADD_COLUMNITEM(COMPRESSEDSIZE,90,LVCFMT_RIGHT);
	//k\bh
	ADD_COLUMNITEM(METHOD,60,LVCFMT_LEFT);
	//k
	ADD_COLUMNITEM(RATIO,60,LVCFMT_RIGHT);
	//CRC
	ADD_COLUMNITEM(CRC,60,LVCFMT_LEFT);

	//----------------------
	// J̕яݒ
	//----------------------
	for(int Count=0;Count<FILEINFO_MAX_NUM;Count++){
		//LȃACe߂
		if(-1==Config.FileListWindow.ColumnOrderArray[Count])break;
	}
	//яϊ
	int TemporaryArray[FILEINFO_MAX_NUM];
	memcpy(TemporaryArray,Config.FileListWindow.ColumnOrderArray,sizeof(TemporaryArray));
	for(int i=0;i<Count;i++){
		int nIndex=UtilCheckNumberArray(m_ColumnIndexArray,FILEINFO_MAX_NUM,TemporaryArray[i]);
		ASSERT(-1!=nIndex);
		if(-1!=nIndex){
			TemporaryArray[i]=nIndex;
		}
	}
	FileListView.SetColumnOrderArray(Count,TemporaryArray);
	return true;
}

LRESULT CFileListFrame::OnDestroy(UINT, WPARAM, LPARAM, BOOL& bHandled)
{
	//EBhEvpeB̉
	RemoveProp(m_hWnd,strPropString);

	//EBhEݒ̕ۑ
	if(Config.FileListWindow.StoreSetting){
		//EBhETCY
		Config.FileListWindow.Width=m_WindowRect.Width();
		Config.FileListWindow.Height=m_WindowRect.Height();

		//c[r[̕
		Config.FileListWindow.TreeWidth=SplitterWindow.GetSplitterPos();
		//\[gݒ
		Config.FileListWindow.SortColumn=SortColumn;
		Config.FileListWindow.SortDescending=bSortDescending;

		//Xgr[̃X^C
		DWORD Style=FileListView.GetWindowLong(GWL_STYLE)%(0x0004);
			 if(LVS_LIST==Style)Config.FileListWindow.ListStyle=LVS_LIST;
		else if(LVS_REPORT==Style)Config.FileListWindow.ListStyle=LVS_REPORT;
		else if(LVS_SMALLICON==Style)Config.FileListWindow.ListStyle=LVS_SMALLICON;
		else /*if(LVS_ICON==Style)*/Config.FileListWindow.ListStyle=LVS_ICON;

		if(Config.FileListWindow.StoreWindowPosition){	//EBhEʒuۑ
			Config.FileListWindow.WindowPos_x=m_WindowRect.left;
			Config.FileListWindow.WindowPos_y=m_WindowRect.top;
		}

		//J̕я擾
		memset(Config.FileListWindow.ColumnOrderArray,-1,FILEINFO_MAX_NUM*sizeof(int));
		const int nCount=FileListView.GetHeader().GetItemCount();
		ASSERT(nCount<=FILEINFO_MAX_NUM);
		FileListView.GetColumnOrderArray(nCount,Config.FileListWindow.ColumnOrderArray);
		//яϊ
		for(int i=0;i<nCount;i++){
			Config.FileListWindow.ColumnOrderArray[i]=m_ColumnIndexArray[Config.FileListWindow.ColumnOrderArray[i]];
		}

		Config.SaveConfig(CONFIG_FILELISTWINDOW);
	}
	else if(Config.FileListWindow.StoreWindowPosition){	//EBhEʒuۑ
		Config.FileListWindow.WindowPos_x=m_WindowRect.left;
		Config.FileListWindow.WindowPos_y=m_WindowRect.top;
		Config.SaveConfig(CONFIG_FILELISTWINDOW);
	}

	bHandled=false;
	return 0;
}

void CFileListFrame::OnCommandCloseWindow(UINT uNotifyCode, int nID, HWND hWndCtl)
{
	DestroyWindow();
}

void CFileListFrame::OnConfigure(UINT uNotifyCode, int nID, HWND hWndCtl)
{
	Config.SaveConfig(CONFIG_FILELISTWINDOW);
	CConfigDialog confdlg(Config);
	if(IDOK==confdlg.DoModal())Config.SaveConfig(CONFIG_LOAD_ALL);
	if(!m_lpArchiver->IsOK())m_lpArchiver->LoadDLL(Config);
	m_MenuCommandArray=Config.FileListWindow.MenuCommandArray;
}

void CFileListFrame::OnSize(UINT uType, CSize)
{
	// NXWM_SIZEbZ[WnhĂяo
	SetMsgHandled(false);

	if(0==uType){//0 (SIZE_RESTORED)EBhETCYύX܂Bŏ܂͍ő剻ł͂܂B
		//ő剻/ŏĂƂɂ̓EBhETCY͎擾Ȃ
		if(IsZoomed()||IsIconic())return;

		GetWindowRect(m_WindowRect);
	}
}

void CFileListFrame::OnMove(const CPoint&)
{
	// NXWM_MOVEbZ[WnhĂяo
	SetMsgHandled(false);

	//ő剻/ŏĂƂɂ̓EBhETCY͎擾Ȃ
	if(IsZoomed()||IsIconic())return;
	GetWindowRect(m_WindowRect);
}

//A[JCuɊ܂܂t@Cꗗ擾
bool CFileListFrame::MakeFileList()
{
	m_lpArchiver=CArchiverDLLManager::GetInstance().GetArchiver(m_strArcFileName,m_idForceDLL);
	if(!m_lpArchiver){
		//sȌ`
		CString msg;
		msg.Format(IDS_FILELIST_FORMAT_UNKNOWN,m_strArcFileName);
		ErrorMessage(msg);
		return false;
	}
	if(!m_lpArchiver->CheckInspectSupported()){
		//{łȂ`
		CString msg;
		msg.Format(IDS_FILELIST_FORMAT_NOTSUPPORTED,m_strArcFileName);
		ErrorMessage(msg);
		return false;
	}

	//u҂v_CAO\
	CWaitDialog WaitDialog;
	WaitDialog.Create(m_hWnd);
	WaitDialog.SetMessageString(CString(MAKEINTRESOURCE(IDS_FILELIST_SEARCH)));
	WaitDialog.ShowWindow(SW_SHOW);
	WaitDialog.UpdateWindow();

	const bool bIgnoreMeaninglessPath=BOOL2bool(Config.FileListWindow.IgnoreMeaninglessPath);	//ӖȃfBNg𖳎

	//͊Jn
	TRACE("fBNg\͊Jn\n");
	if(!m_lpArchiver->InspectArchiveBegin(m_strArcFileName)){
		//XLłȂ
		CString msg;
		msg.Format(IDS_FILELIST_FORMAT_NOTSUPPORTED,m_strArcFileName);
		ErrorMessage(msg);
		WaitDialog.DestroyWindow();
		return false;
	}
	CDTDataContainer dtdc;	//t@CACeێIuWFNg
	while(m_lpArchiver->InspectArchiveNext()){
		dtdc.Clear();
		WaitDialog.AnimationCall();
		//i[t@C擾
		m_lpArchiver->InspectArchiveGetFileName(dtdc.strFullPath);
		dtdc.strTempName=dtdc.strFullPath;
		dtdc.strTempName.Replace(_T('\\'),_T('/'));
		dtdc.TempNameLength=dtdc.strTempName.GetLength();
//		TRACE("===>%s,%s\n",dtdc.FullPath,dtdc.TempName);
		//擾
		dtdc.Attribute=m_lpArchiver->InspectArchiveGetAttribute();
		//t@CTCY(kO)
		if(!m_lpArchiver->InspectArchiveGetOriginalFileSize(dtdc.OriginalSize)){
			dtdc.OriginalSize.LowPart=-1;
			dtdc.OriginalSize.HighPart=-1;
		}
		//t@CTCY(k)
		if(!m_lpArchiver->InspectArchiveGetCompressedFileSize(dtdc.CompressedSize)){
			dtdc.CompressedSize.LowPart=-1;
			dtdc.CompressedSize.HighPart=-1;
		}
		//擾
		if(!m_lpArchiver->InspectArchiveGetWriteTime(dtdc.FileTime)){
			dtdc.FileTime.dwLowDateTime=-1;
			dtdc.FileTime.dwHighDateTime=-1;
		}
		//k
		dtdc.wRatio=m_lpArchiver->InspectArchiveGetRatio();
		//CRC
		dtdc.dwCRC=m_lpArchiver->InspectArchiveGetCRC();
		//\bh
		m_lpArchiver->InspectArchiveGetMethodString(dtdc.strMethod);

		m_RootNode.AddItem(dtdc,bIgnoreMeaninglessPath,Config.FileListWindow.FileListMode);
	}
	//͏I
	m_lpArchiver->InspectArchiveEnd();

	TRACE("fBNg\͏I\n");
//	m_RootNode.ConvertAttribute();
	m_RootNode.PostProcess();
//c[\z
	FileTreeView.MakeTree(&m_RootNode,NULL,BOOL2bool(Config.FileListWindow.ExpandTree),Config.FileListWindow.FileListMode);

	m_lpCurrentNode=&m_RootNode;

	WaitDialog.DestroyWindow();
	return true;
}

LRESULT CFileListFrame::OnDblClick(LPNMHDR pnmh)
{
	TRACE("CFileListFrame::OnDblClick(list)\n");
	//Xgr[̒ʒmȊO͖
	if(pnmh->hwndFrom!=FileListView)return 0;

	//----------------------------------------------------------------------
	//IACe̎:
	// I֘AtŊJ
	//ShiftĂ:
	// I֘AtŊJ
	//IACe̎:
	// tH__uNbN/Enterꍇɂ͂̃tH_J
	// It@Cꍇɂ͊֘AtŊJ
	//----------------------------------------------------------------------

	//IACe̎
	//ShiftĂA֘AtŊJ
	if(GetKeyState(VK_SHIFT)<0||FileListView.GetSelectedCount()>=2){
		OpenAssociation(false,true);
		return 0;
	}

	//Kw\𖳎ꍇɂ́A͖̓
	if(Config.FileListWindow.FileListMode!=FILELIST_TREE)return 0;

	ASSERT(m_lpCurrentNode);
	if(!m_lpCurrentNode)return 0;

	//IꂽACe擾
	int iItem=FileListView.GetNextItem(-1,LVNI_ALL|LVNI_SELECTED);
	if(-1==iItem)return 0;
	CString ItemName;
	CDirectoryTree *dt=GetFileListItemByIndex(iItem);
	if(dt->IsDirectory()){
		if(DownDir(dt))SetFileList();
	}
	else{
		OpenAssociation(false,true);
	}
	return 0;
}

LRESULT CFileListFrame::OnClick(LPNMHDR pnmh)
{
	TRACE("CFileListFrame::OnClick(tree)\n");
//====================
// c[r[̏ꍇ
//====================
	//NbNꂽACeɊ֘Atꂽm[h擾A
	//̔z̃t@CXgr[ɕ\
	if(pnmh->hwndFrom==FileTreeView){
		UINT uFlag;
		CPoint pt = ::GetMessagePos();
		FileTreeView.ScreenToClient(&pt);
		HTREEITEM hItem = FileTreeView.HitTest(pt, &uFlag);
		if(hItem == NULL || !(uFlag & TVHT_ONITEM)){
			return 0;
		}

		ASSERT(m_lpCurrentNode);
		if(!m_lpCurrentNode)return 0;

		CDirectoryTree* Node=(CDirectoryTree*)FileTreeView.GetItemData(hItem);
		ASSERT(Node);
		if(Node){
			if(Node==m_lpCurrentNode)return 0;
			m_lpCurrentNode=Node;
			SetFileList();
		}
	}
	return 0;
}

LRESULT CFileListFrame::OnTreeSelect(LPNMHDR pnmh)
{
	TRACE("CFileListFrame::OnTreeSelect\n");
	//IꂽACeɊ֘Atꂽm[h擾A
	//̔z̃t@CXgr[ɕ\
	if(pnmh->hwndFrom==FileTreeView){
		ASSERT(m_lpCurrentNode);
		if(!m_lpCurrentNode)return 0;

		HTREEITEM hItem=FileTreeView.GetSelectedItem();
		if(!hItem)return 0;

		CDirectoryTree* Node=(CDirectoryTree*)FileTreeView.GetItemData(hItem);
		ASSERT(Node);
		if(Node!=&m_RootNode)m_RootNode.EndFindItem();
		if(Node){
			if(Node==m_lpCurrentNode)return 0;
			m_lpCurrentNode=Node;
			SetFileList();
		}
	}
	return 0;
}


//fBNg@艺
bool CFileListFrame::DownDir(CDirectoryTree* dt)
{
	//Kw\𖳎ꍇɂ́A͖̓
	if(Config.FileListWindow.FileListMode!=FILELIST_TREE)return false;

	m_RootNode.EndFindItem();
	if(!dt){
		return false;
	}
	if(!dt->IsDirectory()){
		//fBNgłȂ΋AĂ炤
		return false;
	}
	m_lpCurrentNode=dt;

	return true;
}

void CFileListFrame::OnUpDir(UINT,int,HWND)
{
	if(UpDir())SetFileList();
}

bool CFileListFrame::UpDir()
{
	TRACE("UpDir\n");
	ASSERT(m_lpCurrentNode);
	if(!m_lpCurrentNode)return false;

	m_RootNode.EndFindItem();
	CDirectoryTree* dt=m_lpCurrentNode->GetParent();
	if(!dt){
		MessageBeep(MB_OK);
		return false;
	}
	TRACE("%s==>%s\n",m_lpCurrentNode->GetName(),dt->GetName());
	m_lpCurrentNode=dt;

	return true;
}

//EBhEgp/sɂ
void CFileListFrame::EnableAll(bool bEnable)
{
	FileListView.EnableWindow(bEnable);
	FileTreeView.EnableWindow(bEnable);

	UIEnable(ID_MENUITEM_LISTVIEW_SMALLICON,bEnable);
	UIEnable(ID_MENUITEM_LISTVIEW_LARGEICON,bEnable);
	UIEnable(ID_MENUITEM_LISTVIEW_REPORT,bEnable);
	UIEnable(ID_MENUITEM_LISTVIEW_LIST,bEnable);
	UIEnable(ID_MENUITEM_EXTRACT_SELECTED,bEnable);
	UIEnable(ID_MENUITEM_DELETE_SELECTED,bEnable);
	UIEnable(ID_MENUITEM_UPDIR,bEnable);
	UIEnable(ID_MENUITEM_SELECT_ALL,bEnable);

	UIEnable(ID_MENUITEM_EXTRACT_ARCHIVE,bEnable);
	UIEnable(ID_MENUITEM_CLEAR_TEMPORARY,bEnable);
	UIEnable(ID_MENUITEM_EXTRACT_SELECTED_SAMEDIR,bEnable);
	UIEnable(ID_MENUITEM_OPEN_ASSOCIATION,bEnable);
	UIEnable(ID_MENUITEM_OPEN_ASSOCIATION_OVERWRITE,bEnable);
	UIEnable(ID_MENUITEM_EXTRACT_TEMPORARY,bEnable);

	UIEnable(ID_MENUITEM_SHOW_COLUMNHEADER_MENU,bEnable);
	UIEnable(ID_MENUITEM_LISTMODE_TREE, bEnable);
	UIEnable(ID_MENUITEM_LISTMODE_FLAT, bEnable);
	UIEnable(ID_MENUITEM_LISTMODE_FLAT_FILESONLY, bEnable);

	UIEnable(ID_MENUITEM_FINDITEM,bEnable);
	UIEnable(ID_MENUITEM_FINDITEM_END,bEnable);
}

bool CFileListFrame::SetArchiveFile(LPCTSTR fname)
{
	Clear();
	CString Title(MAKEINTRESOURCE(IDR_MAINFRAME));
	SetWindowText(Title);
	if(!PathFileExists(fname)){	//݂ȂȂG[
		CString msg;
		msg.Format(IDS_ERROR_FILE_NOT_FOUND,fname);
		ErrorMessage(msg);
		EnableAll(false);
		return false;
	}
	m_strArcFileName=fname;
	m_RootNode.SetArchiveName(fname);

#ifdef __TIMETEST__
	DWORD time=timeGetTime();
#endif// __TIMETEST__

	EnableWindow(FALSE);
	bool bRet=MakeFileList();
	EnableWindow(TRUE);
	SetForegroundWindow(m_hWnd);

	if(!bRet){
		EnableAll(false);
		return false;
	}

#ifdef __TIMETEST__
	DWORD now=timeGetTime();
	TCHAR msg[32]={0};
	sprintf(msg,"%.3fb",(now-time)/1000.0f);
	MessageBox(msg);
#endif// __TIMETEST__

	//EBhE^CgɃt@Cݒ
	Title.Format(_T("%s - %s"),fname,CString(MAKEINTRESOURCE(IDR_MAINFRAME)));
	SetWindowText(Title);

	//Xe[^Xo[̐ݒ
	{
		CString Text;
		Text.Format(IDS_PANE_DLL_NAME,m_lpArchiver->GetName());
		StatusBar.SetPaneText(IDS_PANE_DLL_NAME_INITIAL,Text);
	}

	//ʉ𓀂ł邩H
	m_bExtractEach=m_lpArchiver->QueryExtractSpecifiedOnlySupported(m_strArcFileName);

	//gq.exȅꍇ͎ȉ𓀏ɂ̕ҏWɋC悤x
	if(m_bFirst&&m_lpArchiver->QueryDeleteFileFromArchiveSupported()){
		LPCTSTR ext=PathFindExtension(fname);
		if(ext&&0==_tcsicmp(ext,_T(".exe"))){
			MessageBox(CString(MAKEINTRESOURCE(IDS_WARN_EDIT_SFX)),UtilGetMessageCaption(),MB_OK|MB_ICONEXCLAMATION);
		}
	}
	m_bFirst=false;

	return SetFileList();
}

void CFileListFrame::OnListViewStyle(UINT uNotifyCode,int nID,HWND hWndCtrl)
{
	DWORD Style=FileListView.GetWindowLong(GWL_STYLE);
	Style&=~(LVS_ICON|LVS_REPORT|LVS_SMALLICON|LVS_LIST);
	switch(nID){
	case ID_MENUITEM_LISTVIEW_SMALLICON:
		FileListView.SetWindowLong(GWL_STYLE,Style|LVS_SMALLICON);
		break;
	case ID_MENUITEM_LISTVIEW_LARGEICON:
		FileListView.SetWindowLong(GWL_STYLE,Style|LVS_ICON);
		break;
	case ID_MENUITEM_LISTVIEW_LIST:
		FileListView.SetWindowLong(GWL_STYLE,Style|LVS_LIST);
		break;
	case ID_MENUITEM_LISTVIEW_REPORT:
		FileListView.SetWindowLong(GWL_STYLE,Style|LVS_REPORT);
		break;
	}
	UISetCheck(ID_MENUITEM_LISTVIEW_SMALLICON, false);
	UISetCheck(ID_MENUITEM_LISTVIEW_LARGEICON, false);
	UISetCheck(ID_MENUITEM_LISTVIEW_REPORT, false);
	UISetCheck(ID_MENUITEM_LISTVIEW_LIST, false);
	UISetCheck(nID, true);
}

//JgtH_ȉ̃t@C\
bool CFileListFrame::SetFileList()
{
	TRACE("CFileListFrame::SetFileList()\n");
	ASSERT(m_lpCurrentNode);
	if(!m_lpCurrentNode)return false;
	FileListView.DeleteAllItems();
	FileListView.SetItemCount(m_lpCurrentNode->GetItemCount());
	FileListView.SetItemState(0,LVIS_FOCUSED,LVIS_FOCUSED);

	//c[r[ݒ
	FileTreeView.SetCurrentNode(m_lpCurrentNode);
	//\[gĂ
	m_lpCurrentNode->Sort((FILEINFO_TYPE)SortColumn);

	//uɏv{^̗L/
	if(&m_RootNode==m_lpCurrentNode){
		UIEnable(ID_MENUITEM_UPDIR,false);
	}
	else{
		UIEnable(ID_MENUITEM_UPDIR,true);
	}

	return true;
}

//Xgr[ł̃ACeԍɑΉt@CACe擾
CDirectoryTree* CFileListFrame::GetFileListItemByIndex(int iIndex)
{
	ASSERT(m_lpCurrentNode);
	if(!m_lpCurrentNode)return NULL;
	ASSERT(iIndex>=0&&m_lpCurrentNode->GetItemCount()>iIndex);
	if(iIndex<0||m_lpCurrentNode->GetItemCount()<=iIndex)return NULL;

	if(bSortDescending){
		return m_lpCurrentNode->GetChild(iIndex);
	}
	else{
		return m_lpCurrentNode->GetChild(m_lpCurrentNode->GetItemCount()-1-iIndex);
	}
}

//zXgr[̃ACe擾ɔ
LRESULT CFileListFrame::OnGetDispInfo(LPNMHDR pnmh)
{
	LV_DISPINFO* pstLVDInfo=(LV_DISPINFO*)pnmh;

	CDirectoryTree *Node=GetFileListItemByIndex(pstLVDInfo->item.iItem);
	if(!Node)return 0;

	//Y`FbN
	if(pstLVDInfo->item.iSubItem<0||pstLVDInfo->item.iSubItem>=FILEINFO_MAX_NUM)return 0;

	switch(m_ColumnIndexArray[pstLVDInfo->item.iSubItem]){
	case FILEINFO_FILENAME:	//t@C
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			_tcsncpy(pstLVDInfo->item.pszText, Node->GetName(),pstLVDInfo->item.cchTextMax);
		}
		if(pstLVDInfo->item.mask & LVIF_IMAGE){
			pstLVDInfo->item.iImage=m_ShellDataManager.GetIconIndex(Node->GetExt());
		}
		break;
	case FILEINFO_FULLPATH:	//i[pX
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			_tcsncpy(pstLVDInfo->item.pszText, Node->GetFullPath(),pstLVDInfo->item.cchTextMax);
		}
		break;
	case FILEINFO_ORIGINALSIZE:	//TCY(kO)
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			CString strBuffer;
			GetInfoTip_FileSize(strBuffer,Node->GetOriginalSize(),Config.FileListWindow.DisplayFileSizeInByte);
			_tcsncpy(pstLVDInfo->item.pszText,strBuffer,pstLVDInfo->item.cchTextMax);
		}
		break;
	case FILEINFO_COMPRESSEDSIZE:	//TCY(k)
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			CString strBuffer;
			GetInfoTip_FileSize(strBuffer,Node->GetCompressedSize(),Config.FileListWindow.DisplayFileSizeInByte);
			_tcsncpy(pstLVDInfo->item.pszText,strBuffer,pstLVDInfo->item.cchTextMax);
		}
		break;
	case FILEINFO_TYPENAME:	//t@C^Cv
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			_tcsncpy(pstLVDInfo->item.pszText,m_ShellDataManager.GetTypeName(Node->GetExt()),pstLVDInfo->item.cchTextMax);
		}
		break;
	case FILEINFO_FILETIME:	//t@C
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			CString Buffer;
			GetInfoTip_FileTime(Buffer,Node->GetFileTimePtr());
			_tcsncpy(pstLVDInfo->item.pszText,Buffer,pstLVDInfo->item.cchTextMax);
		}
		break;
	case FILEINFO_ATTRIBUTE:	//
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			int Attribute=Node->GetAttribute();
			CString Info;
			if(Attribute&FA_UNKNOWN){
				Info+=_T("?????");
			}
			else{
				if(Attribute&FA_RDONLY)Info+=_T("R");
				else Info+=_T("-");
				if(Attribute&FA_HIDDEN)Info+=_T("H");
				else Info+=_T("-");
				if(Attribute&FA_SYSTEM)Info+=_T("S");
				else Info+=_T("-");
				if(Attribute&FA_DIREC)Info+=_T("D");
				else Info+=_T("-");
				if(Attribute&FA_ARCH)Info+=_T("A");
				else Info+=_T("-");
			}
			_tcsncpy(pstLVDInfo->item.pszText,Info,pstLVDInfo->item.cchTextMax);
		}
		break;
	case FILEINFO_METHOD:	//k\bh
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			_tcsncpy(pstLVDInfo->item.pszText,Node->GetMethod(),pstLVDInfo->item.cchTextMax);
		}
		break;
	case FILEINFO_RATIO:	//k
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			WORD wRatio=Node->GetRatio();
			if(0xFFFF==wRatio){
				//擾s
				_tcsncpy(pstLVDInfo->item.pszText,_T("?????"),pstLVDInfo->item.cchTextMax);
			}
			else{
				_sntprintf(pstLVDInfo->item.pszText,pstLVDInfo->item.cchTextMax,_T("%.1f%%"),(double)wRatio/10.0);
			}
		}
		break;
	case FILEINFO_CRC:	//CRC
		if(pstLVDInfo->item.mask & LVIF_TEXT){
			DWORD dwCRC=Node->GetCRC();
			if(-1==dwCRC){
				//擾s
				_tcsncpy(pstLVDInfo->item.pszText,_T("?????"),pstLVDInfo->item.cchTextMax);
			}
			else{
				_sntprintf(pstLVDInfo->item.pszText,pstLVDInfo->item.cchTextMax,_T("%08x"),dwCRC);
			}
		}
		break;
	}
	return 0;
}

//zXgr[̃c[`bv擾ɔ
LRESULT CFileListFrame::OnGetInfoTip(LPNMHDR pnmh)
{
	LPNMLVGETINFOTIP pGetInfoTip=(LPNMLVGETINFOTIP)pnmh;

	CDirectoryTree *Node=GetFileListItemByIndex(pGetInfoTip->iItem);
	ASSERT(Node);
	if(!Node)return 0;
	const int Attribute=Node->GetAttribute();
	if(!Node)return 0;
	CString strInfo;

	//t@C
	strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_FILENAME));
	strInfo+=_T(" : ");
	strInfo+=Node->GetName();
	strInfo+=_T("\n");
	//i[pX
	strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_FULLPATH));
	strInfo+=_T(" : ");
	strInfo+=Node->GetFullPath();
	strInfo+=_T("\n");
	//kOTCY
	strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_ORIGINALSIZE));
	strInfo+=_T(" : ");
	{
		CString Buffer;
		GetInfoTip_FileSize(Buffer,Node->GetOriginalSize(),Config.FileListWindow.DisplayFileSizeInByte);
		strInfo+=Buffer;
	}

	strInfo+=_T("\n");
	//t@C^Cv
	strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_TYPENAME));
	strInfo+=_T(" : ");
	strInfo+=m_ShellDataManager.GetTypeName(Node->GetExt());
	strInfo+=_T("\n");
	//t@C
	strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_FILETIME));
	strInfo+=_T(" : ");
	{
		CString Buffer;
		GetInfoTip_FileTime(Buffer,Node->GetFileTimePtr());
		strInfo+=Buffer;
	}
	strInfo+=_T("\n");
	//
	strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_ATTRIBUTE));
	strInfo+=_T(" : ");
	if(Attribute&FA_UNKNOWN)strInfo+=_T("?????");
	else{
		if(Attribute&FA_RDONLY)strInfo+=_T("R");
		if(Attribute&FA_HIDDEN)strInfo+=_T("H");
		if(Attribute&FA_SYSTEM)strInfo+=_T("S");
		if(Attribute&FA_DIREC)strInfo+=_T("D");
		if(Attribute&FA_ARCH)strInfo+=_T("A");
	}
	strInfo+=_T("\n");
	//kTCY
	strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_COMPRESSEDSIZE));
	strInfo+=_T(" : ");
	{
		CString Buffer;
		GetInfoTip_FileSize(Buffer,Node->GetCompressedSize(),Config.FileListWindow.DisplayFileSizeInByte);
		strInfo+=Buffer;
	}
	strInfo+=_T("\n");
	//k\bh
	strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_METHOD));
	strInfo+=_T(" : ");
	{
		strInfo+=Node->GetMethod();
	}
	strInfo+=_T("\n");
	//k
	strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_RATIO));
	strInfo+=_T(" : ");
	{
		WORD wRatio=Node->GetRatio();
		if(0xFFFF==wRatio){
			//擾s
			strInfo+=_T("?????");
		}
		else{
			TCHAR szBuffer[8];
			_sntprintf(szBuffer,8,_T("%.1f%%"),(double)wRatio/10.0);
			strInfo+=szBuffer;
		}
	}
	strInfo+=_T("\n");
	//CRC
	strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_COLUMN_CRC));
	strInfo+=_T(" : ");
	{
		DWORD dwCRC=Node->GetCRC();
		if(-1==dwCRC){
			//擾s
			strInfo+=_T("?????");
		}
		else{
			TCHAR szBuffer[16];
			_sntprintf(szBuffer,16,_T("%08x"),dwCRC);
			strInfo+=szBuffer;
		}
	}

	if(Attribute&FA_DIREC){
		//--------------
		// fBNg
		//--------------
		//qm[h̐\
		strInfo+=_T("\n");
		strInfo+=CString(MAKEINTRESOURCE(IDS_FILELIST_SUBITEM));
		strInfo+=_T(" : ");
		CString Temp;
		Temp.Format(IDS_FILELIST_ITEMCOUNT,Node->GetItemCount());
		strInfo+=Temp;
	}

	//InfoTipɐݒ
	_tcsncpy(pGetInfoTip->pszText,strInfo,pGetInfoTip->cchTextMax);
	return 0;
}


void CFileListFrame::GetInfoTip_FileSize(CString &Info,LARGE_INTEGER Size,BOOL bInByte)
{
	Info.Empty();
	if(-1==Size.LowPart&&-1==Size.HighPart){
		Info=_T("---");
		return;
	}

	static CString OrderUnit[]={MAKEINTRESOURCE(IDS_ORDERUNIT_BYTE),MAKEINTRESOURCE(IDS_ORDERUNIT_KILOBYTE),MAKEINTRESOURCE(IDS_ORDERUNIT_MEGABYTE),MAKEINTRESOURCE(IDS_ORDERUNIT_GIGABYTE),MAKEINTRESOURCE(IDS_ORDERUNIT_TERABYTE)};	//TCY̒P
	static const int MAX_ORDERUNIT=sizeof(OrderUnit)/sizeof(LPCTSTR);

	if(bInByte){	//t@CTCYoCgPʂŕ\L
		TCHAR Buffer[64]={0};
		_snprintf(Buffer,63,OrderUnit[0],Size);
		Info=Buffer;
		return;
	}

	for(int Order=0;Order<MAX_ORDERUNIT;Order++){
		if(Size.QuadPart<1024*1024){
			break;
		}
		Size.QuadPart=Int64ShrlMod32(Size.QuadPart,10);	//1024Ŋ
	}
	if(0==Order){
		if(Size.QuadPart<1024){
			//1KBɖȂ̂ŃoCgPʂł̂܂ܕ\L
			TCHAR Buffer[64]={0};
			_snprintf(Buffer,63,OrderUnit[0],Size);
			Info=Buffer;
			return;
		}
	}
	TCHAR Buffer[64]={0};
	if(Order<MAX_ORDERUNIT-1){
		double SizeToDisplay=Size.QuadPart/1024.0f;
		Order++;
		_snprintf(Buffer,63,OrderUnit[Order],SizeToDisplay);
	}
	else{
		_snprintf(Buffer,63,OrderUnit[Order],Size.QuadPart);
	}
	Info=Buffer;
}

void CFileListFrame::GetInfoTip_FileTime(CString &Info,LPFILETIME lpFileTime)
{
	Info.Empty();
	if(-1==lpFileTime->dwHighDateTime&&-1==lpFileTime->dwLowDateTime){
		Info=_T("------");
	}
	else{
		FILETIME LocalFileTime;
		SYSTEMTIME SystemTime;

		FileTimeToLocalFileTime(lpFileTime,&LocalFileTime);
		FileTimeToSystemTime(&LocalFileTime, &SystemTime);
		TCHAR Buffer[64];

		wsprintf(Buffer,CString(MAKEINTRESOURCE(IDS_FILELIST_FILETIME_FORMAT)),
				SystemTime.wYear, SystemTime.wMonth, SystemTime.wDay,
				SystemTime.wHour, SystemTime.wMinute,SystemTime.wSecond);
		Info+=Buffer;
	}
}

//Xgr[ƃc[r[ŃtH[JX؂ւ
void CFileListFrame::OnToggleFocus(UINT,int,HWND)
{
	if(GetFocus()==FileListView){
		FileTreeView.SetFocus();
	}
	else{
		FileListView.SetFocus();
	}
}

LRESULT CFileListFrame::OnFocus(LPNMHDR pnmh)
{
	if(!m_lpArchiver)return 0;
	const bool bFileListActive=(::GetFocus()==FileListView);

	const bool bCanExtractSelected=bFileListActive&&m_bExtractEach&&(FileListView.GetSelectedCount()>0);
	UIEnable(ID_MENUITEM_EXTRACT_SELECTED,bCanExtractSelected);
	UIEnable(ID_MENUITEM_EXTRACT_SELECTED_SAMEDIR,bCanExtractSelected);
	UIEnable(ID_MENUITEM_OPEN_ASSOCIATION,bCanExtractSelected);
	UIEnable(ID_MENUITEM_OPEN_ASSOCIATION_OVERWRITE,bCanExtractSelected);
	UIEnable(ID_MENUITEM_EXTRACT_TEMPORARY,bCanExtractSelected);

	UIEnable(ID_MENUITEM_DELETE_SELECTED,bFileListActive&&m_lpArchiver->QueryDeleteFileFromArchiveSupported()&&(FileListView.GetSelectedCount()>0));

	return 0;
}

LRESULT CFileListFrame::OnItemChanged(LPNMHDR pnmh)
{
	if(!m_lpArchiver)return 0;
	if(pnmh->hwndFrom==FileListView){
		int FileCount=FileListView.GetSelectedCount();
		const bool bCanExtractSelected=m_bExtractEach&&(FileListView.GetSelectedCount()>0);
		UIEnable(ID_MENUITEM_EXTRACT_SELECTED,bCanExtractSelected);
		UIEnable(ID_MENUITEM_EXTRACT_SELECTED_SAMEDIR,bCanExtractSelected);
		UIEnable(ID_MENUITEM_OPEN_ASSOCIATION,bCanExtractSelected);
		UIEnable(ID_MENUITEM_OPEN_ASSOCIATION_OVERWRITE,bCanExtractSelected);
		UIEnable(ID_MENUITEM_EXTRACT_TEMPORARY,bCanExtractSelected);

		UIEnable(ID_MENUITEM_DELETE_SELECTED,m_lpArchiver->QueryDeleteFileFromArchiveSupported()&&(FileCount>0));

		CString Text;
		Text.Format(IDS_PANE_ITEMCOUNT,FileListView.GetItemCount(),FileCount);
		StatusBar.SetPaneText(IDS_PANE_ITEMCOUNT_INITIAL,Text);
	}
	return 0;
}

//t@CXgXV
void CFileListFrame::OnRefresh(UINT,int,HWND)
{
	std::stack<CString> DirStack;
	//JgfBNg̕ۑ
	if(m_lpCurrentNode){
		CDirectoryTree *dt=m_lpCurrentNode;
		for(;dt!=&m_RootNode;dt=dt->GetParent()){
			DirStack.push(dt->GetName());
		}
	}
	if(!SetArchiveFile(m_strArcFileName))return;

	EnableAll(true);

	//JgfBNg̕
	while(!DirStack.empty()){
		m_lpCurrentNode=m_lpCurrentNode->GetChild(DirStack.top());
		DirStack.pop();
		if(!m_lpCurrentNode){
			m_lpCurrentNode=&m_RootNode;
			return;
		}
	}
	SetFileList();
}

void CFileListFrame::Clear()
{
	m_lpArchiver=NULL;
	m_lpCurrentNode=&m_RootNode;
	FileListView.DeleteAllItems();
	FileTreeView.Clear();
	m_RootNode.Clear();
}

void CFileListFrame::OnExtract(UINT,int nID,HWND)
{
	//A[JCuƓtH_ɉ𓀂ꍇtrue
	const bool bSameDir=(ID_MENUITEM_EXTRACT_SELECTED_SAMEDIR==nID);

	ASSERT(m_lpArchiver);
	if(!m_lpArchiver){
		return;// false;
	}
	if(!m_bExtractEach){
		//It@C̉𓀂̓T|[gĂȂ
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILELIST_EXTRACT_SELECTED_NOT_SUPPORTED)));
		return;// false;
	}

	if(!PathFileExists(m_strArcFileName)){	//݂ȂȂG[
		CString msg;
		msg.Format(IDS_ERROR_FILE_NOT_FOUND,m_strArcFileName);
		ErrorMessage(msg);
		EnableAll(false);
		return;// false;
	}
	//O
	m_lpArchiver->PreExtractSpecifiedOnly();
	//IꂽACe
	std::list<CDirectoryTree*> ItemList;
	int Index=-1;
	while(true){
		Index = FileListView.GetNextItem(Index, LVNI_ALL | LVNI_SELECTED);
		if(-1==Index)break;
		CDirectoryTree* dt=GetFileListItemByIndex(Index);

		ASSERT(dt);
		if(!dt)continue;

		ItemList.push_back(dt);
	}
	if(ItemList.empty()){
		//Iꂽt@CȂ
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILELIST_NOT_SELECTED)));
		return;// false;
	}

	//--------------
	// o͐̎擾
	//--------------
	TCHAR OutputBaseDir[_MAX_PATH+1];
	FILL_ZERO(OutputBaseDir);
	EXTRACT_TO ExtractTo=Config.Common.Extract.OutputDirType;
	if(bSameDir){
		ExtractTo=EXTRACT_TO_SAME_DIR;
	}
	switch(ExtractTo){
	case EXTRACT_TO_DESKTOP:	//Desktop
		if(!SHGetSpecialFolderPath(NULL,OutputBaseDir,CSIDL_DESKTOPDIRECTORY,FALSE)){
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_GET_DESKTOP)));
//			return;
		}
		break;
	case EXTRACT_TO_SAME_DIR:	//Same Directory
		_tcsncpy(OutputBaseDir,m_strArcFileName,_MAX_PATH);
		PathRemoveFileSpec(OutputBaseDir);
		break;
	case EXTRACT_TO_SPECIFIC_DIR:	//Specific Directory
		TRACE("Specific Dir:%s\n",Config.Common.Extract.OutputDir);
		if(0>=_tcslen(Config.Common.Extract.OutputDir)){
			//o͐悪ĂȂ΁AfXNgbvɏo͂
			if(!SHGetSpecialFolderPath(NULL,OutputBaseDir,CSIDL_DESKTOPDIRECTORY,FALSE)){
				ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_GET_DESKTOP)));
//				return false;
			}
		}
		else{
			_tcsncpy(OutputBaseDir,Config.Common.Extract.OutputDir,_MAX_PATH);
		}
		break;
	case EXTRACT_TO_ALWAYS_ASK_WHERE:	//o͐𖈉񕷂
		TRACE("Always ask\n");
		break;
	}
	PathAddBackslash(OutputBaseDir);
	TRACE("%s\n",OutputBaseDir);
	if(!bSameDir){
		//vZbgςݏo̓tH_J
		CString title(MAKEINTRESOURCE(IDS_INPUT_TARGET_FOLDER));
		CLFFolderDialog dlg(m_hWnd,title,BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE);
		dlg.SetInitialFolder(OutputBaseDir);
		if(IDOK!=dlg.DoModal()){
			return;
		}
		_tcsncpy(OutputBaseDir,dlg.GetFolderPath(),_MAX_PATH);
		PathAddBackslash(OutputBaseDir);
	}

	//EBhEgps
	EnableWindow(FALSE);

	//
	ExtractEx(m_lpArchiver,m_strArcFileName,m_lpCurrentNode,ItemList,OutputBaseDir,m_RootNode.IsFindMode());

	//EBhEgp\
	EnableWindow(TRUE);
	SetForegroundWindow(m_hWnd);
}


void CFileListFrame::OnSelectAll(UINT,int,HWND)
{
	FileListView.SetItemState(-1, LVIS_SELECTED, LVIS_SELECTED);
	FileListView.SetFocus();
}


void CFileListFrame::OnExtractArchive(UINT,int,HWND)
{
	if(!PathFileExists(m_strArcFileName)){	//݂ȂȂG[
		CString msg;
		msg.Format(IDS_ERROR_FILE_NOT_FOUND,m_strArcFileName);
		ErrorMessage(msg);
		EnableAll(false);
		return;// false;
	}

	//EBhEgps
	EnableWindow(FALSE);

	//
	std::list<CString> ArchiveList;
	ArchiveList.push_back(m_strArcFileName);
	Extract(ArchiveList,Config,m_idForceDLL,NULL);

	//EBhEgp\
	EnableWindow(TRUE);
	SetForegroundWindow(m_hWnd);
}



//L[͂ɂt@C
LRESULT CFileListFrame::OnFindItem(LPNMHDR pnmh)
{
	if(pnmh->hwndFrom!=FileListView){
		return 0;
	}
	if(!m_lpCurrentNode)return -1;

	int iCount=m_lpCurrentNode->GetItemCount();
	if(iCount<=0)return -1;

	LPNMLVFINDITEM lpFindInfo = (LPNMLVFINDITEM)pnmh;
	int iStart=lpFindInfo->iStart;
	if(iStart<0)iStart=0;
	if(lpFindInfo->lvfi.flags&LVFI_STRING||lpFindInfo->lvfi.flags&LVFI_PARTIAL){	//t@CŌ
		LPCTSTR FindString=lpFindInfo->lvfi.psz;
		int Length=_tcslen(FindString);
		//vŌ
		for(int i=iStart;i<iCount;i++){
			CDirectoryTree* dt=GetFileListItemByIndex(i);
			ASSERT(dt);
			if(0==_tcsnicmp(FindString,dt->GetName(),Length)){
				return i;
			}
		}
		if(lpFindInfo->lvfi.flags&LVFI_WRAP){
			for(i=0;i<iStart;i++){
				CDirectoryTree* dt=GetFileListItemByIndex(i);
				ASSERT(dt);
				if(0==_tcsnicmp(FindString,dt->GetName(),Length)){
					return i;
				}
			}
		}
		return -1;
	}
	else{
		return -1;
	}
}

//\[g
LRESULT CFileListFrame::OnSortItem(LPNMHDR pnmh)
{
	if(pnmh->hwndFrom!=FileListView){
		return 0;
	}
	if(!m_lpCurrentNode)return 0;

	LPNMLISTVIEW lpNMLV=(LPNMLISTVIEW)pnmh;
	int iCol=lpNMLV->iSubItem;
	if(!(iCol >= 0 && iCol < FILEINFO_MAX_NUM))return 0;

	if(iCol==SortColumn){
		if(!bSortDescending){	//\[g
			bSortDescending = !bSortDescending;
			iCol=FILEINFO_INVALID;
		}
		else{
			bSortDescending = !bSortDescending;
			SetFileList();
			return 0;
		}
	}

	//1ȉȂ\[g͕KvȂ
	if(m_lpCurrentNode->GetItemCount()<=1){
		return 0;
	}

//	m_lpCurrentNode->Sort((FILEINFO_TYPE)iCol);
	SortColumn=iCol;
	SetFileList();
	return 0;
}

void CFileListFrame::OnDelete(UINT uNotifyCode,int nID,HWND hWndCtrl)
{
	ASSERT(m_lpArchiver);
	if(!m_lpArchiver){
		return;// false;
	}
	if(!m_lpArchiver->QueryDeleteFileFromArchiveSupported()){
		//It@C̍폜̓T|[gĂȂ
		if(1==uNotifyCode){	//ANZ[^瑀
			MessageBeep(MB_OK);
		}
		else{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILELIST_DELETE_SELECTED_NOT_SUPPORTED)));
		}
		return;// false;
	}

	if(!PathFileExists(m_strArcFileName)){	//݂ȂȂG[
		CString msg;
		msg.Format(IDS_ERROR_FILE_NOT_FOUND,m_strArcFileName);
		ErrorMessage(msg);
		EnableAll(false);
		return;// false;
	}
	//Iꂽt@C
	std::list<CString> FileList;	//t@Cp
	int Index=-1;
	while(true){
		Index = FileListView.GetNextItem(Index, LVNI_ALL | LVNI_SELECTED);
		if(-1==Index)break;
		CDirectoryTree* dt=GetFileListItemByIndex(Index);

		ASSERT(dt);
		if(!dt)continue;

		dt->EnumFiles(FileList);
	}

	//t@CIĂȂ΃G[
	if(FileList.empty()){
		if(1==uNotifyCode){	//ANZ[^瑀
			MessageBeep(MB_OK);
		}
		else{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILELIST_NOT_SELECTED)));
		}
		return;// false;
	}

	//mF
	if(IDYES!=MessageBox(CString(MAKEINTRESOURCE(IDS_ASK_FILELIST_DELETE_SELECTED)),UtilGetMessageCaption(),MB_YESNO|MB_DEFBUTTON2|MB_ICONEXCLAMATION)){
		return;
	}

	//EBhEgps
	EnableWindow(FALSE);
	//----------------
	// t@C
	//----------------
	if(!FileList.empty()){
		m_lpArchiver->DeleteFileFromArchive(m_strArcFileName,FileList);
	}

	//EBhEgp\
	EnableWindow(TRUE);
	SetForegroundWindow(m_hWnd);
	//A[JCueXV
	OnRefresh(uNotifyCode,nID,hWndCtrl);
}


LRESULT CFileListFrame::OnBeginDrag(LPNMHDR pnmh)
{
	ASSERT(m_lpArchiver);
	if(!m_lpArchiver){
		return 0;
	}
	if(!m_bExtractEach){
		//It@C̉𓀂̓T|[gĂȂ
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILELIST_EXTRACT_SELECTED_NOT_SUPPORTED)));
		return 0;
	}

	if(!PathFileExists(m_strArcFileName)){	//݂ȂȂG[
		CString msg;
		msg.Format(IDS_ERROR_FILE_NOT_FOUND,m_strArcFileName);
		ErrorMessage(msg);
		EnableAll(false);
		return 0;
	}
	//O
	m_lpArchiver->PreExtractSpecifiedOnly();
	//IꂽACe
	std::list<CDirectoryTree*> ItemList;
	int Index=-1;
	while(true){
		Index = FileListView.GetNextItem(Index, LVNI_ALL | LVNI_SELECTED);
		if(-1==Index)break;
		CDirectoryTree* dt=GetFileListItemByIndex(Index);

		ASSERT(dt);
		if(!dt)continue;

		ItemList.push_back(dt);
	}
	if(ItemList.empty()){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILELIST_NOT_SELECTED)));
		return 0;
	}

	EnableWindow(FALSE);

	//hbO&hbvŉ
	DnD.DragDrop(m_strArcFileName,m_lpArchiver,ItemList,m_lpCurrentNode);

	EnableWindow(TRUE);
	SetForegroundWindow(m_hWnd);

	return 0;
}

//J\On/Off؂ւ
//\:YJ\ɂAzl߂
//\:gĂȂɎwJǉ
void _ToggleColumn(int *lpArray,size_t size,FILEINFO_TYPE type)
{
	ASSERT(lpArray);
	if(!lpArray)return;

	for(size_t i=0;i<size;i++){
		if(type==lpArray[i]){
			//zl߂
			for(size_t j=i;j<size-1;j++){
				lpArray[j]=lpArray[j+1];
			}
			lpArray[size-1]=-1;
			return;
		}
		else if(-1==lpArray[i]){
			lpArray[i]=type;
			return;
		}
	}
}

void CFileListFrame::OnShowCustomizeColumn(UINT,int,HWND)
{
	//Jwb_ҏWj[\邽߁AJwb_̉ENbNG~[g
	BOOL bTemp;
	NMHDR nmhdr;
	nmhdr.hwndFrom=FileListView.GetHeader();
	CFileListFrame::OnColumnClick(0, &nmhdr, bTemp);
}

//Jwb_/ENbN
LRESULT CFileListFrame::OnColumnClick(int /*idCtrl*/, LPNMHDR pnmh, BOOL& bHandled)
{
	//bZ[W͏ȂƂɂ
	bHandled = FALSE;

	if(pnmh->hwndFrom!=FileListView.GetHeader()){
		return 0;
	}

	//ENbNj[\
	POINT point;
	GetCursorPos(&point);
	CMenu cMenu;
	cMenu.LoadMenu(IDR_LISTVIEW_HEADER_MENU);
	CMenuHandle cSubMenu(cMenu.GetSubMenu(0));

	//--------------------------------
	// ej[ACe̗LE
	//--------------------------------

	bool bEnabled;
	//tpX
	bEnabled=(-1!=UtilCheckNumberArray(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_FULLPATH));
	cSubMenu.CheckMenuItem(ID_MENUITEM_LISTVIEW_COLUMN_FULLPATH,MF_BYCOMMAND|(bEnabled?MF_CHECKED:MF_UNCHECKED));

	//kOTCY
	bEnabled=(-1!=UtilCheckNumberArray(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_ORIGINALSIZE));
	cSubMenu.CheckMenuItem(ID_MENUITEM_LISTVIEW_COLUMN_ORIGINALSIZE,MF_BYCOMMAND|(bEnabled?MF_CHECKED:MF_UNCHECKED));

	//t@C
	bEnabled=(-1!=UtilCheckNumberArray(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_TYPENAME));
	cSubMenu.CheckMenuItem(ID_MENUITEM_LISTVIEW_COLUMN_TYPENAME,MF_BYCOMMAND|(bEnabled?MF_CHECKED:MF_UNCHECKED));

	//XV
	bEnabled=(-1!=UtilCheckNumberArray(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_FILETIME));
	cSubMenu.CheckMenuItem(ID_MENUITEM_LISTVIEW_COLUMN_FILETIME,MF_BYCOMMAND|(bEnabled?MF_CHECKED:MF_UNCHECKED));

	//
	bEnabled=(-1!=UtilCheckNumberArray(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_ATTRIBUTE));
	cSubMenu.CheckMenuItem(ID_MENUITEM_LISTVIEW_COLUMN_ATTRIBUTE,MF_BYCOMMAND|(bEnabled?MF_CHECKED:MF_UNCHECKED));

	//kTCY
	bEnabled=(-1!=UtilCheckNumberArray(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_COMPRESSEDSIZE));
	cSubMenu.CheckMenuItem(ID_MENUITEM_LISTVIEW_COLUMN_COMPRESSEDSIZE,MF_BYCOMMAND|(bEnabled?MF_CHECKED:MF_UNCHECKED));

	//k\bh
	bEnabled=(-1!=UtilCheckNumberArray(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_METHOD));
	cSubMenu.CheckMenuItem(ID_MENUITEM_LISTVIEW_COLUMN_METHOD,MF_BYCOMMAND|(bEnabled?MF_CHECKED:MF_UNCHECKED));

	//k
	bEnabled=(-1!=UtilCheckNumberArray(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_RATIO));
	cSubMenu.CheckMenuItem(ID_MENUITEM_LISTVIEW_COLUMN_RATIO,MF_BYCOMMAND|(bEnabled?MF_CHECKED:MF_UNCHECKED));

	//CRC
	bEnabled=(-1!=UtilCheckNumberArray(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_CRC));
	cSubMenu.CheckMenuItem(ID_MENUITEM_LISTVIEW_COLUMN_CRC,MF_BYCOMMAND|(bEnabled?MF_CHECKED:MF_UNCHECKED));


	//j[\:IR}hԂĂ
	int nRet=cSubMenu.TrackPopupMenu(TPM_NONOTIFY|TPM_RETURNCMD|TPM_LEFTALIGN|TPM_RIGHTBUTTON,point.x, point.y, m_hWnd,NULL);

	switch(nRet){
	case 0:
		//Not Selected
		return 0;
	case ID_MENUITEM_LISTVIEW_COLUMN_FULLPATH:	//tpX
		_ToggleColumn(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_FULLPATH);
		break;
	case ID_MENUITEM_LISTVIEW_COLUMN_ORIGINALSIZE:	//kOTCY
		_ToggleColumn(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_ORIGINALSIZE);
		break;
	case ID_MENUITEM_LISTVIEW_COLUMN_TYPENAME:	//t@C
		_ToggleColumn(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_TYPENAME);
		break;
	case ID_MENUITEM_LISTVIEW_COLUMN_FILETIME:	//XV
		_ToggleColumn(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_FILETIME);
		break;
	case ID_MENUITEM_LISTVIEW_COLUMN_ATTRIBUTE:	//
		_ToggleColumn(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_ATTRIBUTE);
		break;
	case ID_MENUITEM_LISTVIEW_COLUMN_COMPRESSEDSIZE:	//kTCY
		_ToggleColumn(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_COMPRESSEDSIZE);
		break;
	case ID_MENUITEM_LISTVIEW_COLUMN_METHOD:	//k\bh
		_ToggleColumn(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_METHOD);
		break;
	case ID_MENUITEM_LISTVIEW_COLUMN_RATIO:	//k
		_ToggleColumn(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_RATIO);
		break;
	case ID_MENUITEM_LISTVIEW_COLUMN_CRC:	//CRC
		_ToggleColumn(Config.FileListWindow.ColumnOrderArray,FILEINFO_MAX_NUM,FILEINFO_CRC);
		break;
	case ID_MENUITEM_LISTVIEW_COLUMN_RESET:	//
		{
			for(int i=0;i<FILEINFO_MAX_NUM;i++){
				Config.FileListWindow.ColumnOrderArray[i]=i;
			}
		}
		break;
	}

	//Jč\z
	int nCount=FileListView.GetHeader().GetItemCount();
	for(;nCount>0;nCount--){
		FileListView.DeleteColumn(nCount-1);
	}

	SetListViewColumn();

	//bZ[WƂɂ
	bHandled = TRUE;

	return 0;
}


//ReLXgj[J
void CFileListFrame::OnContextMenu(HWND hWndCtrl,CPoint &Point)
{
	if(-1==Point.x&&-1==Point.y){
		//L[{[h̓͂łꍇ
		//Xgr[̍ɕ\
		Point.x=Point.y=0;
		FileListView.ClientToScreen(&Point);
	}
	else{
		//}EXE{^t@CꗗEBhEŉꂽ̂łȂΕԂ
		CPoint ptTemp(Point);
		FileListView.ScreenToClient(&ptTemp);
		if(-1==FileListView.HitTest(ptTemp,NULL)){
			SetMsgHandled(false);
			return;
		}

		//}EXE{^t@CꗗEBhE*J*ŉꂽ̂łΕԂ
		HDHITTESTINFO hdHitTestInfo={0};
		hdHitTestInfo.pt=Point;
		FileListView.GetHeader().ScreenToClient(&hdHitTestInfo.pt);
		FileListView.GetHeader().HitTest(&hdHitTestInfo);
		if(hdHitTestInfo.flags&HHT_ONHEADER){
			return;
		}
	}

	//---ENbNj[\
	CMenu cMenu;
	cMenu.LoadMenu(IDR_FILELIST_POPUP);
	CMenuHandle cSubMenu(cMenu.GetSubMenu(0));

	if(!m_MenuCommandArray.empty()){	//---[U[wc[()ǉ
		//R}hǉ邽߂̃Tuj[T
		int MenuCount=cSubMenu.GetMenuItemCount();
		int iIndex=-1;
		for(int i=0;i<=MenuCount;i++){
			if(-1==cSubMenu.GetMenuItemID(i)){	//|bvAbv̐e
				iIndex=i;
				break;
			}
		}
		ASSERT(-1!=iIndex);
		if(-1!=iIndex){
			CMenuHandle cSubSubMenu(cSubMenu.GetSubMenu(iIndex));
			cSubSubMenu.RemoveMenu(0,MF_BYPOSITION);
			for(UINT u=0;u<m_MenuCommandArray.size();u++){
				cSubSubMenu.InsertMenu(-1,MF_BYPOSITION|MF_STRING,(UINT_PTR)(ID_MENUITEM_USERAPP_BEGIN+u),m_MenuCommandArray[u].Caption);
			}
		}
	}

	cSubMenu.TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,Point.x, Point.y, m_hWnd,NULL);
}


void CFileListFrame::OnOpenAssociation(UINT uNotifyCode,int nID,HWND hWndCtrl)
{
	//trueȂ瑶݂e|t@C폜Ă𓀂
	const bool bOverwrite=(nID==ID_MENUITEM_OPEN_ASSOCIATION_OVERWRITE);
	OpenAssociation(bOverwrite,true);
}

//bOverwrite:trueȂ瑶݂e|t@C폜Ă𓀂
bool CFileListFrame::OpenAssociation(bool bOverwrite,bool bOpen)
{
	ASSERT(m_lpArchiver);
	if(!m_lpArchiver){
		return false;
	}
	if(!m_bExtractEach){
		//It@C̉𓀂̓T|[gĂȂ
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILELIST_EXTRACT_SELECTED_NOT_SUPPORTED)));
		return false;
	}

	if(!PathFileExists(m_strArcFileName)){	//݂ȂȂG[
		CString msg;
		msg.Format(IDS_ERROR_FILE_NOT_FOUND,m_strArcFileName);
		ErrorMessage(msg);
		EnableAll(false);
		return false;
	}
	//O
	m_lpArchiver->PreExtractSpecifiedOnly();

	//IꂽACe
	std::list<CDirectoryTree*> ItemList;
	int Index=-1;
	LPCTSTR lpTempDir=m_TempDirManager.GetDirPath();
	while(true){
		Index = FileListView.GetNextItem(Index, LVNI_ALL | LVNI_SELECTED);
		if(-1==Index)break;
		CDirectoryTree* dt=GetFileListItemByIndex(Index);

		ASSERT(dt);
		if(!dt)continue;

		//------------------------
		// ݂`FbNA𓀍ς݂ł΂J
		TCHAR szPath[_MAX_PATH+1]={0};
		_tcsncpy(szPath,lpTempDir,_MAX_PATH);

		CString strTemp;
		const bool bDir=dt->IsDirectory();
		if(bDir){
			//fBNg
			CDirectoryTree::GetDirPathRelative(dt,&m_RootNode,strTemp);
		}
		else{
			//t@C
			strTemp=dt->GetFullPath();
			UtilModifyPath(strTemp);
		}
		PathAppend(szPath,strTemp);

		//ۂꂽ㏑ǉ𓀂Ȃ;fBNgȂ狑ۂ̂݃`FbN
		if(!UtilPathAcceptSpec(szPath,Config.FileListWindow.OpenAssoc.Deny,Config.FileListWindow.OpenAssoc.Accept,dt->IsDirectory())){
			MessageBeep(MB_ICONEXCLAMATION);
			continue;
		}

		if(bOverwrite){
			//--------------------------------------------
			// ㏑𓀂̂ŁA݂t@C͍폜
			//--------------------------------------------
			if(bDir){
				if(PathIsDirectory(szPath)){
					UtilDeleteDir(szPath,true);
				}
			}
			else{
				if(PathFileExists(szPath)){
					UtilDeletePath(szPath);
				}
			}
			//𓀗vXgɉ
			ItemList.push_back(dt);
		}
		else{	//㏑͂Ȃ
			if(
				(bDir&&PathIsDirectory(szPath))||
				(!bDir&&PathFileExists(szPath))
				){
				//------------------------------------------
				// LbV݂ȂA𗘗p
				//------------------------------------------
				TRACE("Open:using cache:%s\n",szPath);
				if(bOpen){
					ShellExecute(GetDesktopWindow(),/*_T("open")*/NULL,szPath,NULL,NULL,SW_SHOW);
				}
			}
			else{
				//𓀗vXgɉ
				ItemList.push_back(dt);
			}
		}
	}
	if(ItemList.empty()){
		//ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILELIST_NOT_SELECTED)));
		return true;
	}

	//𓀂݈̂̕ꎞtH_ɉ
	ExtractEx(m_lpArchiver,m_strArcFileName,&m_RootNode,ItemList,m_TempDirManager.GetDirPath(),false);

	//֘AtŊJ
	for(std::list<CDirectoryTree*>::iterator ite=ItemList.begin();ite!=ItemList.end();ite++){
		TCHAR szPath[_MAX_PATH+1]={0};
		_tcsncpy(szPath,lpTempDir,_MAX_PATH);

		CString strTemp;
		if((*ite)->IsDirectory()){
			//fBNg
			CDirectoryTree::GetDirPathRelative(*ite,&m_RootNode,strTemp);
		}
		else{
			//t@C
			strTemp=(*ite)->GetFullPath();
			UtilModifyPath(strTemp);
		}

		if(bOpen){
			PathAppend(szPath,strTemp);

			TRACE("Open:newly:%s\n",szPath);
			ShellExecute(GetDesktopWindow(),/*_T("open")*/NULL,szPath,NULL,NULL,SW_SHOW);
		}
	}
	return true;
}

void CFileListFrame::OnExtractTemporary(UINT uNotifyCode,int nID,HWND hWndCtrl)
{
	//㏑͂邪AJȂ
	OpenAssociation(true,false);
}

void CFileListFrame::OnClearTemporary(UINT uNotifyCode,int nID,HWND hWndCtrl)
{
	m_TempDirManager.ClearSubDir();
}

void CFileListFrame::OnListMode(UINT uNotifyCode,int nID,HWND hWndCtrl)
{
	FILELISTMODE NewMode=Config.FileListWindow.FileListMode;
	switch(nID){
	case ID_MENUITEM_LISTMODE_TREE:
		NewMode=FILELIST_TREE;
		break;
	case ID_MENUITEM_LISTMODE_FLAT:
		NewMode=FILELIST_FLAT;
		break;
	case ID_MENUITEM_LISTMODE_FLAT_FILESONLY:
		NewMode=FILELIST_FLAT_FILESONLY;
		break;
	}

	if(Config.FileListWindow.FileListMode==NewMode)return;

	Config.FileListWindow.FileListMode=NewMode;
	UISetCheck(ID_MENUITEM_LISTMODE_TREE, false);
	UISetCheck(ID_MENUITEM_LISTMODE_FLAT, false);
	UISetCheck(ID_MENUITEM_LISTMODE_FLAT_FILESONLY, false);
	UISetCheck(nID, true);

	OnRefresh(0,0,0);
}

LRESULT CFileListFrame::OnUserApp(WORD wNotifyCode, WORD wID, HWND hWndCtl,BOOL&)	//uvOŊJṽnh
{
	ASSERT(!m_MenuCommandArray.empty());
	ASSERT(ID_MENUITEM_USERAPP_BEGIN<=wID&&wID<=ID_MENUITEM_USERAPP_END);
	if(ID_MENUITEM_USERAPP_BEGIN>wID||wID>ID_MENUITEM_USERAPP_END)return 0;

	UINT iIndex=wID-ID_MENUITEM_USERAPP_BEGIN;
	ASSERT(iIndex>=0&&iIndex<m_MenuCommandArray.size());
	if(iIndex<0||iIndex>=m_MenuCommandArray.size())return 0;

	//---I𓀊Jn
	if(!m_bExtractEach){
		//It@C̉𓀂̓T|[gĂȂ
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILELIST_EXTRACT_SELECTED_NOT_SUPPORTED)));
		return false;
	}
	if(!PathFileExists(m_strArcFileName)){	//݂ȂȂG[
		CString msg;
		msg.Format(IDS_ERROR_FILE_NOT_FOUND,m_strArcFileName);
		ErrorMessage(msg);
		EnableAll(false);
		return false;
	}
	//O
	m_lpArchiver->PreExtractSpecifiedOnly();

	//IꂽACe
	std::list<CDirectoryTree*> NeedExtractList;
	std::list<CString> ItemList;
	int Index=-1;
	LPCTSTR lpTempDir=m_TempDirManager.GetDirPath();
	while(true){
		Index = FileListView.GetNextItem(Index, LVNI_ALL | LVNI_SELECTED);
		if(-1==Index)break;
		CDirectoryTree* dt=GetFileListItemByIndex(Index);

		ASSERT(dt);
		if(!dt)continue;

		//------------------------
		// ݂`FbNA𓀍ς݂ł΂J
		TCHAR szPath[_MAX_PATH+1]={0};
		_tcsncpy(szPath,lpTempDir,_MAX_PATH);

		CString strTemp;
		const bool bDir=dt->IsDirectory();
		if(bDir){
			//fBNg
			CDirectoryTree::GetDirPathRelative(dt,&m_RootNode,strTemp);
		}
		else{
			//t@C
			strTemp=dt->GetFullPath();
			UtilModifyPath(strTemp);
		}
		PathAppend(szPath,strTemp);

		if(
			(bDir&&!PathIsDirectory(szPath))||
			(!bDir&&!PathFileExists(szPath))
			){
			//𓀗vXgɉ
			NeedExtractList.push_back(dt);
		}

		//ACeǉ
		ItemList.push_back(szPath);
	}
	if(!NeedExtractList.empty()){
		//𓀂݈̂̕ꎞtH_ɉ
		ExtractEx(m_lpArchiver,m_strArcFileName,&m_RootNode,NeedExtractList,m_TempDirManager.GetDirPath(),false);
	}

	//---s擾
	CString strPath(m_MenuCommandArray[iIndex].Path);
	CString strParam(m_MenuCommandArray[iIndex].Param);
	CString strDir(m_MenuCommandArray[iIndex].Dir);

	//u
	if(-1!=strParam.Find(_T("%F"))){
		//t@CꗗAč쐬
		CString strFileList;
		for(std::list<CString>::iterator ite=ItemList.begin();ite!=ItemList.end();ite++){
			TCHAR szBuffer[_MAX_PATH+3];
			strncpy(szBuffer,*ite,_MAX_PATH+2);
			PathQuoteSpaces(szBuffer);
			strFileList+=szBuffer;
			strFileList+=_T(" ");
		}
		strParam.Replace(_T("%F"),strFileList);
	}else if(-1!=strParam.Find(_T("%S"))){
		for(std::list<CString>::iterator ite=ItemList.begin();ite!=ItemList.end();ite++){
			strParam=m_MenuCommandArray[iIndex].Param;
			TCHAR szBuffer[_MAX_PATH+3];
			strncpy(szBuffer,*ite,_MAX_PATH+2);
			PathQuoteSpaces(szBuffer);
			strParam.Replace(_T("%S"),szBuffer);
			//---s
			::ShellExecute(GetDesktopWindow(),NULL,strPath,strParam,strDir,SW_SHOW);
		}
		return 0;
	}

	//---s
	::ShellExecute(GetDesktopWindow(),NULL,strPath,strParam,strDir,SW_SHOW);

	return 0;
}

void CFileListFrame::OnFindItem(UINT uNotifyCode,int nID,HWND hWndCtrl)
{
	if(ID_MENUITEM_FINDITEM_END==nID){
		m_RootNode.EndFindItem();
		SetFileList();
		return;
	}
	CString strSpec;
	if(!UtilInputText(CString(MAKEINTRESOURCE(IDS_INPUT_FIND_PARAM)),strSpec))return;
	m_RootNode.FindItem(strSpec,m_lpCurrentNode);
	m_lpCurrentNode=&m_RootNode;
	SetFileList();
}

void CFileListFrame::OnOpenArchive(UINT uNotifyCode,int nID,HWND hWndCtrl)
{
	CFileDialog dlg(TRUE, NULL, NULL, OFN_OVERWRITEPROMPT|OFN_NOCHANGEDIR);
	if(IDCANCEL==dlg.DoModal()){	//LZ
		return;
	}
	//gdN\
	TCHAR ExePath[_MAX_PATH+1];
	FILL_ZERO(ExePath);
	GetModuleFileName(GetModuleHandle(NULL),ExePath,_MAX_PATH);

	//t@C𕡐nꂽ玩g𕡐NAꂼɃXg\
	CString Param(_T("/l "));
	PathQuoteSpaces(dlg.m_szFileName);
	Param+=dlg.m_szFileName;
	ShellExecute(NULL,NULL,ExePath,Param,NULL,SW_RESTORE);
}
