#pragma once
//Original code from http://hp.vector.co.jp/authors/VA016117/
//Modified by Claybird http://claybird.hp.infoseek.co.jp/

#include "../../common.h"
#include <vector>

class CEnumFORMATETC : public IEnumFORMATETC
{
friend class CEnumFORMATETC;
public:
	CEnumFORMATETC() : _RefCount(1){
		_current = 0;
		_num = 0;
	};
	~CEnumFORMATETC(){};

	virtual HRESULT __stdcall QueryInterface(const IID& iid, void** ppv);
	virtual ULONG __stdcall AddRef(void);
	virtual ULONG __stdcall Release(void);

	virtual HRESULT __stdcall Next(ULONG celt, FORMATETC * rgelt, ULONG * pceltFetched);
	virtual HRESULT __stdcall Skip(ULONG celt);
	virtual HRESULT __stdcall Reset(void);
	virtual HRESULT __stdcall Clone(IEnumFORMATETC ** ppenum);

	bool allocate(int num);
	BOOL SetFormat(FORMATETC *fmt);
private:
	LONG _RefCount;
protected:
	class CData{
	public:
		FORMATETC	fmt;
	};

	std::vector<CData> _fmt;
	int		_current, _num;
};
