#pragma once

#include <hash_map>
#include <string>
#include "../common.h"

class SHELLDATA{
public:
	int IconIndex;
	CString TypeName;
};

//VFǗNX
//ACRAt@C^CvȂ
class CShellDataManager
{
protected:
	HIMAGELIST			ImageListSmall;
	HIMAGELIST			ImageListLarge;
	std::hash_map<std::string,SHELLDATA> ShellDataMap;
	std::hash_map<std::string,SHELLDATA>::iterator CShellDataManager::RegisterData(LPCTSTR Ext,DWORD Attribute=FILE_ATTRIBUTE_NORMAL);
public:
	void Init();
	HIMAGELIST GetImageList(bool bLarge);
	int GetIconIndex(LPCTSTR);
	LPCTSTR GetTypeName(LPCTSTR);
};
