#include "common.h"
#include "WaitDialog.h"

LRESULT CWaitDialog::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	Static_MessageString=GetDlgItem(IDC_STATIC_WAIT_MESSAGE);
	Static_Icon=GetDlgItem(IDC_STATIC_ANIMATION_ICON);

	{
		CImageList ImageList;
		ImageList.Create(MAKEINTRESOURCE(IDB_BITMAP_ANIMATION),32,1,RGB(0,0,0));
		MaxIconCount=ImageList.GetImageCount();
		CurrentIconNumber=0;
		IconAnimation=new CIcon[MaxIconCount];
		for(int i=0;i<MaxIconCount;i++){
			IconAnimation[i]=ImageList.ExtractIcon(i);
		}
		LastTime=0;
	}

	// eEBhE̒ɔzu
	CenterWindow();

	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);

	return TRUE;
}

void CWaitDialog::OnDestroy()
{
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->RemoveMessageFilter(this);
	pLoop->RemoveIdleHandler(this);

	delete [] IconAnimation;
}
