#pragma once
#include "../common.h"
#include "../resource.h"

class CWaitDialog : public CDialogImpl<CWaitDialog>,public CMessageFilter, public CIdleHandler
{
protected:
	CStatic	Static_MessageString;
	CStatic Static_Icon;
	CIcon *IconAnimation;
	int MaxIconCount;
	int CurrentIconNumber;
	DWORD LastTime;
	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CMainDlg)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
		COMMAND_ID_HANDLER_EX(IDOK, NULL)
		COMMAND_ID_HANDLER_EX(IDCANCEL, NULL)
	END_MSG_MAP()

    LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	void OnDestroy();

	BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

	BOOL OnIdle(){
		return FALSE;
	}
public:
	enum {IDD = IDD_DIALOG_WAIT};
	void SetMessageString(LPCTSTR t){Static_MessageString.SetWindowText(t);}
	inline void AnimationCall(){
		DWORD Now=timeGetTime();
		if(Now-LastTime<200)return;
		LastTime=Now;
		CurrentIconNumber++;
		CurrentIconNumber%=MaxIconCount;
		Static_Icon.SetIcon(IconAnimation[CurrentIconNumber]);
	}
};
