#pragma once

//A[JCovWFNgdl̃t@C
#define FA_RDONLY		0x01			// ݕی쑮
#define FA_HIDDEN		0x02			// B
#define FA_SYSTEM		0x04			// VXe
#define FA_LABEL		0x08			// {[Ex
#define FA_DIREC		0x10			// fBNg
#define FA_ARCH			0x20			// A[JCu
#define FA_UNKNOWN		0x40			// sȑ(LhaForge̓Ǝg)


enum FILELISTMODE{	//t@CꗗEBhE̕\@
	FILELIST_TREE,				//GNXv[CÑfBNgKw\
	FILELIST_FLAT,				//tH_Kw𖳎ĕ\
	FILELIST_FLAT_FILESONLY,	//tH_Kw𖳎At@Ĉݕ\
	FILELISTMODE_MAX_NUM
};


//tH_̎ʕ(gq)
const LPCTSTR FOLDER_EXTENSION_STRING=_T("***");


//t@C
enum FILEINFO_TYPE{
	FILEINFO_INVALID=-1,
	FILEINFO_FILENAME,		//t@C
	FILEINFO_FULLPATH,		//tpX
	FILEINFO_ORIGINALSIZE,	//kOt@CTCY
	FILEINFO_TYPENAME,		//t@Cޖ
	FILEINFO_FILETIME,		//t@CŏIXV
	FILEINFO_ATTRIBUTE,		//t@C
	FILEINFO_COMPRESSEDSIZE,//kt@CTCY
	FILEINFO_METHOD,		//k\bh
	FILEINFO_RATIO,			//k
	FILEINFO_CRC,			//CRC
	FILEINFO_MAX_NUM
};


class CDTDataContainer{	//t@CACeێ
public:
	CString strFullPath;
	CString	strTempName;	//pXɎgobt@BpX؂肪S/ɒuĂ
	int TempNameLength;
	int Index;		//TempNamẻڂQƂĂ邩
	CString strMethod;	//k\bh
	WORD wRatio;		//k
	DWORD dwCRC;		//CRC
	int Attribute;
	LARGE_INTEGER OriginalSize;
	LARGE_INTEGER CompressedSize;
	FILETIME FileTime;
	inline void Clear(){
		strFullPath.Empty();
		strTempName.Empty();
		Index=0;
		TempNameLength=0;
		strMethod.Empty();	//k\bh
		wRatio=-1;		//k
		Attribute=0;

		OriginalSize.LowPart=-1;
		OriginalSize.HighPart=0;

		CompressedSize.LowPart=-1;
		CompressedSize.HighPart=0;

		dwCRC=-1;

		FileTime.dwLowDateTime=0;
		FileTime.dwHighDateTime=0;
	}
};

//struct COMP;

//fBNgc[ێ
class CDirectoryTree{
protected:
	CString			m_strExt;			//t@Cgq
	bool			m_bDir;			//fBNgǂ
	CString			m_strNodeName;		//Zp[^Ő؂ꂽO
	int				m_NodeNameLength;	//NodeName̒
	CString			m_strFullPath;		//i[ꂽƂ̖O;Ԑȅꍇɂ́A̓A[JCut@CƂȂ
	int				m_Attribute;		//tH_ǂȂǂ̏
	CString			m_strMethod;		//k\bh
	WORD			m_wRatio;			//k
	DWORD			m_dwCRC;			//CRC
	CDirectoryTree*	m_lpParent;			//em[h̃|C^
	LARGE_INTEGER	m_OriginalSize;		//i[t@C̈kÕTCY(fBNgȂAɓĂt@CTCY̍v)
	LARGE_INTEGER	m_CompressedSize;	//i[t@C̈k̃TCY(fBNgȂAɓĂt@CTCY̍v)

	FILETIME		m_FileTime;		//i[t@CŏIXV
	std::list<CDirectoryTree*> m_NonFileNodeList;	//t@CłȂm[ĥ݂o^Ă;NodeArraỹRs[
	std::vector<CDirectoryTree*> m_NodeArray;
	std::vector<CDirectoryTree*> m_NodeArrayOriginal;

	bool AddItem_Flat(CDTDataContainer&,const bool bIgnoreMeaninglessPath,const bool bFilesOnly);

	bool m_bFindMode;	//[hȂtrue
	//bMatchPath:trueȂpX܂ߌAfalseȂt@Ĉ݌
	void _FindItem(LPCTSTR lpszMask,bool bMatchPath,std::vector<CDirectoryTree*> &retArray);
public:
	CDirectoryTree();
	virtual ~CDirectoryTree();
	bool				AddItem(CDTDataContainer&,const bool bIgnore,FILELISTMODE FileListMode);
	LPCTSTR				GetName(){return m_strNodeName;}
	LPCTSTR				GetFullPath(){return m_strFullPath;}
	int					GetAttribute(){return m_Attribute;}
	LPCTSTR				GetExt(){return m_strExt;}
	LARGE_INTEGER		GetOriginalSize(){return m_OriginalSize;}
	LARGE_INTEGER		GetCompressedSize(){return m_CompressedSize;}
	LPCTSTR				GetMethod(){return m_strMethod;}
	WORD				GetRatio(){return m_wRatio;}
	DWORD				GetCRC(){return m_dwCRC;}
	LPFILETIME			GetFileTimePtr(){return &m_FileTime;}
	CDirectoryTree*		GetParent(){return m_lpParent;}
	CDirectoryTree*		GetChild(LPCTSTR);
	CDirectoryTree*		GetChild(int Index){return m_NodeArray[Index];}
	int					GetItemCount(){return m_NodeArray.size();}
	bool				IsDirectory(){return m_bDir;}
	std::vector<CDirectoryTree*>::iterator GetIterator(bool bBegin){if(bBegin)return m_NodeArray.begin();else return m_NodeArray.end();}

	//lpTopȉ̃t@C
	//bMatchPath:trueȂpX܂ߌAfalseȂt@Ĉ݌
	void FindItem(LPCTSTR lpszMask,CDirectoryTree *lpTop);
	void EndFindItem(){
		if(m_bFindMode){
			m_NodeArray=m_NodeArrayOriginal;
		}
		m_bFindMode=false;
	}
	bool IsFindMode(){return m_bFindMode;}

	void PostProcess();		//fBNgt@C̃TCY擾

	void SetArchiveName(LPCTSTR fname){
		if(m_lpParent)return;	//Ԑȅꍇ݂̂̑삪
		m_strFullPath=fname;
	}
	void Clear();

	//ȉ̃t@C
	bool EnumFiles(std::list<CString>&);

	//\[g֌W
	void Sort(FILEINFO_TYPE);
	friend struct COMP;

	//[g݂Ď̊i[ĂefBNg܂ł̃pX擾
	static void GetDirPathRelative(CDirectoryTree *lpDir,const CDirectoryTree *lpBase,CString &);
};
