/////////////////////////////////////////////////////////////////////////////
//
// Last update	$Date: 2007/04/01 14:06:20 $ UTC
//   Revision   $Revision: 1.9 $
//
//	Renamed and Modified by Claybird <claybird.without.wing@gmail.com> 2005 May 23
// Main.cpp :	DLL AvP[Vp̃Gg |Cg`
//				LhaForgegVFDLL
//
//	Original File Information:
// TfShell.cpp :	DLL AvP[Vp̃Gg |Cg`
//					l(TF)gVFDLL
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ShellExtClassFactory.h"
#include "registry.h"
#include "main.h"
#include <crtdbg.h>

//ENbNj[nh
// {713B479F-6F2B-48e9-B545-5591CCFE398F}
static const GUID CLSID_ShellExtShellMenu = 
{ 0x713b479f, 0x6f2b, 0x48e9, { 0xb5, 0x45, 0x55, 0x91, 0xcc, 0xfe, 0x39, 0x8f } };

//EhbOj[nh
// {5E5B692B-D6ED-4103-A1FA-9A71A93DAC88}
static const GUID CLSID_ShellExtDragMenu = 
{ 0x5e5b692b, 0xd6ed, 0x4103, { 0xa1, 0xfa, 0x9a, 0x71, 0xa9, 0x3d, 0xac, 0x88 } };

long		g_cDllRef		= 0;
HINSTANCE	g_hInstDLL		= NULL;
HWND		g_hWndMcpAppl	= NULL;

//DLLɃRg𖄂ߍł
#pragma comment(exestr,_T("Shell Extension Module for LhaForge by Claybird"))

BOOL WINAPI DllMain(
	HINSTANCE	hInstance,
	DWORD		dwReason,
	LPVOID		lpReserved)
{
#if defined(_DEBUG)
	// [Nop
	_CrtSetDbgFlag(
		_CRTDBG_ALLOC_MEM_DF
		| _CRTDBG_LEAK_CHECK_DF
		);
#endif
	UNREFERENCED_PARAMETER(lpReserved);

    if (dwReason == DLL_PROCESS_ATTACH)	{
		dprintf("DllMain : DLL_PROCESS_ATTACH \n");
		g_hInstDLL = hInstance;
	}
	else if (dwReason == DLL_PROCESS_DETACH)	{
		dprintf("DllMain : DLL_PROCESS_DETACH ~\n");
	}

    return 1;
}

// DLLA[h\`FbN
STDAPI DllCanUnloadNow(void)
{
	dprintf("DllCanUnloadNow[%s(g_cDllRef=%d)]\n",
				((g_cDllRef == 0) ? "S_OK" : "S_FALSE"),g_cDllRef);
    return g_cDllRef == 0 ? S_OK : S_FALSE;
}


// NXt@Ngv
STDAPI DllGetClassObject(
	REFCLSID	rclsid,
	REFIID		riid,
	LPVOID*		ppvOut)
{
	dprintf("DllGetClassObject\n");

	HRESULT hr = CLASS_E_CLASSNOTAVAILABLE;
	*ppvOut = NULL;

	CShellExtClassFactory *pcf=NULL;
	if(IsEqualIID(rclsid, CLSID_ShellExtShellMenu)){
		// NXt@Ng̍쐬
		pcf = new CShellExtClassFactory(false);
		dprintf("DllGetClassObject:new CShellExtClassFactory(%8X):ShellMenu\n",pcf);
		// C^[tF[X̗v
		hr = pcf->QueryInterface(riid, ppvOut);
	}
	else if(IsEqualIID(rclsid, CLSID_ShellExtDragMenu)){
		// NXt@Ng̍쐬
		pcf = new CShellExtClassFactory(true);
		dprintf("DllGetClassObject:new CShellExtClassFactory(%8X):DragMenu\n",pcf);
		// C^[tF[X̗v
		hr = pcf->QueryInterface(riid, ppvOut);
	}

	return hr;
}

// WXgo^
STDAPI DllRegisterServer()
{
	dprintf("DllRegisterServer\n");
	bool bFirst=(S_OK==RegisterServer(g_hInstDLL,CLSID_ShellExtShellMenu,false));
	bool bSecond=(S_OK==RegisterServer(g_hInstDLL,CLSID_ShellExtDragMenu,true));
	return (bFirst&&bSecond) ? S_OK : E_FAIL;
}


// WXgo^
STDAPI DllUnregisterServer()
{
	dprintf("DllUnregisterServer\n");
	bool bFirst=(S_OK==UnregisterServer(CLSID_ShellExtShellMenu,false));
	bool bSecond=(S_OK==UnregisterServer(CLSID_ShellExtDragMenu,true));
	return (bFirst&&bSecond) ? S_OK : E_FAIL;
}

#ifdef _DEBUG
// Oo
extern void dprintf(
	const char	*inFormat,
	...)
{
	char	thePath[_MAX_PATH];
	FILE	*theFileP;
	va_list	arg;
	GetModuleFileName(g_hInstDLL, thePath, sizeof(thePath));
	strcat(thePath, ".log");
	theFileP = fopen(thePath, "a");
	if (!theFileP)	return;
	va_start(arg, inFormat);
	vfprintf(theFileP, inFormat, arg);
/*		char theBuf[512];
		vsprintf(theBuf, inFormat, arg);*/
	va_end(arg);
//	OutputDebugString(theBuf);
	fclose(theFileP);
}
#endif
