#include "stdafx.h"
#include "lfutil.h"

bool UtilInsertMenuItem(HMENU hMenu,LPCTSTR lpszCaption,int indexMenu,HMENU hSubMenu,WORD wID)
{
	ASSERT(IsMenu(hMenu));
	MENUITEMINFO mii={0};
	mii.cbSize = sizeof(mii);

	SetLastError(0);
	if(lpszCaption){
		if(hSubMenu){
			//Tuj[t
			mii.fMask = MIIM_SUBMENU | MIIM_ID | MIIM_STRING;
			mii.hSubMenu=hSubMenu;
			mii.wID = wID;
		}
		else{
			//Pƍ
			mii.fMask = MIIM_ID | MIIM_STRING;
			mii.wID = wID;
		}
		mii.dwTypeData=const_cast<LPTSTR>(lpszCaption);
		mii.cch=strlen(lpszCaption);

		//TRUE:indexMenu͈ʒu\킷
		if(::InsertMenuItem(hMenu, indexMenu, TRUE,&mii)){
			UtilTraceLastError();
			dprintf("Succeeded\n");
			return true;
		}
		UtilTraceLastError();
		dprintf("Failed\n");

		//}Ɏs
		//MIIM_STRINGOAMFS_STRINGǉ
		mii.fMask&=~MIIM_STRING;
		mii.fMask|=MIIM_FTYPE;	//MIIM_TYPE
		mii.fType=MFT_STRING;

		if(::InsertMenuItem(hMenu, indexMenu, TRUE,&mii)){
			UtilTraceLastError();
			dprintf("Retry Succeeded\n");
			return true;
		}
		UtilTraceLastError();
		dprintf("Failed Again\n");
		return false;
	}
	else{
	//----------------------------------------
	//Separatorǉ̏ꍇAlpszCaptionNULL
	//----------------------------------------
		mii.fMask = MIIM_ID | MIIM_TYPE;
		mii.fType=MFT_SEPARATOR;
		mii.wID = wID;
		if(::InsertMenuItem(hMenu, indexMenu, TRUE,&mii)){
			UtilTraceLastError();
			dprintf("Separator:Succeeded\n");
			return true;
		}
		else{
			mii.fMask = MIIM_ID | MIIM_FTYPE;
			if(::InsertMenuItem(hMenu, indexMenu, TRUE,&mii)){
				UtilTraceLastError();
				dprintf("Separator:Retry Succeeded\n");
				return true;
			}
			else{
				UtilTraceLastError();
				dprintf("Separator:Failed\n");
				return false;
			}
		}
	}
}

//t@CɈs
bool UtilWriteLine(HANDLE hFile,LPCTSTR lpszText)
{
	if(INVALID_HANDLE_VALUE==hFile)return false;
	DWORD dwWritten;
	if(!WriteFile(hFile,lpszText,_tcslen(lpszText)*sizeof(lpszText[0]),&dwWritten,NULL))return false;
	TCHAR CRLF[]=_T("\r\n");
	if(!WriteFile(hFile,CRLF,_tcslen(CRLF)*sizeof(CRLF[0]),&dwWritten,NULL))return false;

	return true;
}

//INIɎw肳ꂽZNVȂtrueԂ
bool UtilCheckINISectionExists(LPCTSTR lpAppName,LPCTSTR lpFileName)
{
	TCHAR szBuffer[10];
	DWORD dwRead=GetPrivateProfileSection(lpAppName,szBuffer,9,lpFileName);
	return dwRead>0;
}

