#pragma once

#include "config.h"
#include "../resource.h"

//====================================
// BGA̐ݒ荀
//====================================
class CConfigBGA : public CDialogImpl<CConfigBGA>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	CEdit			Edit_GZA_Level;
	CTrackBarCtrl	Track_GZA_Level;

	CEdit			Edit_BZA_Level;
	CTrackBarCtrl	Track_BZA_Level;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_BGA };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigBGA)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_HSCROLL(OnHScroll)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	void OnHScroll(int, short, HWND);

	CConfigBGA(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE("CConfigBGA()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

