#include "common.h"
#include "config_cab.h"

//=================
// CABʐݒ
//=================
LRESULT CConfigCAB::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//----------------
	// k`̑I
	//----------------
	Radio_CompressType[CAB_COMPRESS_MSZIP]=GetDlgItem(IDC_RADIO_CAB_MSZIP);
	Radio_CompressType[CAB_COMPRESS_LZX]=GetDlgItem(IDC_RADIO_CAB_LZX);
	Radio_CompressType[CAB_COMPRESS_PLAIN]=GetDlgItem(IDC_RADIO_CAB_PLAIN);

	Radio_CompressType[Config.CAB.CompressType].SetCheck(1);

	//-------------------------------
	// LZXkx̐ݒpXC_
	//-------------------------------
	Track_LZX_Level=GetDlgItem(IDC_SLIDER_CAB_LZX_LEVEL);
	Track_LZX_Level.SetRange(CAB_LZX_LOWEST,CAB_LZX_HIGHEST);
	Track_LZX_Level.SetTicFreq(1);
	Track_LZX_Level.SetPageSize(1);
	Track_LZX_Level.SetLineSize(1);
	Track_LZX_Level.SetPos(Config.CAB.LZX_Level);

	//---------------------------------
	// LZXkx̊mFpGfBbg
	//---------------------------------
	Edit_LZX_Level=GetDlgItem(IDC_EDIT_CAB_LZX_LEVEL);
	TCHAR Buffer[5];
	FILL_ZERO(Buffer);
	_itot(Config.CAB.LZX_Level,Buffer,10);
	Edit_LZX_Level.SetWindowText(Buffer);

	//LZXIĂȂΈkx̐ݒ͖ɂĂ
	bool bActive=(0!=Radio_CompressType[CAB_COMPRESS_LZX].GetCheck());
	Track_LZX_Level.EnableWindow(bActive);
	Edit_LZX_Level.EnableWindow(bActive);

	return TRUE;
}

LRESULT CConfigCAB::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//----------------
	// k`̑I
	//----------------
	for(int Type=0;Type<CAB_COMPRESS_TYPE_MAX_NUM;Type++){
		if(Radio_CompressType[Type].GetCheck()){
			Config.CAB.CompressType=(CAB_COMPRESS_TYPE)Type;
			break;
		}
	}

	//---------------
	// LZXkx
	//---------------
	Config.CAB.LZX_Level=Track_LZX_Level.GetPos();

	return TRUE;
}


void CConfigCAB::OnHScroll(int, short, HWND)
{
	TCHAR Buffer[5];
	_itot(Track_LZX_Level.GetPos(),Buffer,10);
	Edit_LZX_Level.SetWindowText(Buffer);
}

LRESULT CConfigCAB::OnRadioCompressType(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		bool bActive=(0!=Radio_CompressType[CAB_COMPRESS_LZX].GetCheck());
		Track_LZX_Level.EnableWindow(bActive);
		Edit_LZX_Level.EnableWindow(bActive);
	}
	return 0;
}
