#pragma once
#include "../common.h"
#include "../resource.h"
#include "../util.h"

class CConfigDetail : public CDialogImpl<CConfigDetail>,public CMessageFilter
{
protected:
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_DETAIL };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigVersion)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);

	CConfigDetail(){
		TRACE("CConfigDetail()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

