#pragma once

#include "config.h"
#include "../resource.h"
#include <atlddx.h>		// DDX/DDVgp邽

//====================================
// JACK̐ݒ荀
//====================================
class CConfigJACK : public CDialogImpl<CConfigJACK>,public CWinDataExchange<CConfigJACK>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	CButton			Radio_SpecifyVolumeSize[2];
	int				VolumeSize;
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}


public:
	enum { IDD = IDD_PROPPAGE_CONFIG_JACK };
	// DDX}bv
	BEGIN_DDX_MAP(CConfigJACK)
		DDX_INT(IDC_EDIT_JACK_VOLUME_SIZE, VolumeSize)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigJACK)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_RANGE_HANDLER(IDC_RADIO_JACK_VOLUME_SIZE_USE_STORED_SETTING,IDC_RADIO_JACK_VOLUME_SIZE_SPECIFY_AT_COMPRESS, OnRadioVolumeSize)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	LRESULT OnRadioVolumeSize(WORD,WORD,HWND,BOOL&);

	CConfigJACK(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE("CConfigJACK()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

