#include "common.h"
#include "config_shellext.h"
#include "shellmanager.h"

//==============
// ʐݒ
//==============
LRESULT CConfigShellExt::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//------------------
	// VFg̗L
	//------------------
	DefaultShellExtStatus=ShellRegistCheck();

	Check_ShellExt=GetDlgItem(IDC_CHECK_SHELL_EXT);
	Check_ShellExt.SetCheck(DefaultShellExtStatus);

	Check_ShellExtForceExtra=GetDlgItem(IDC_CHECK_SHELL_EXT_FORCE_EXTRA);

	//DDXAbvf[g
	DoDataExchange(FALSE);

	BOOL bActive=Check_ShellExt.GetCheck();
	::EnableWindow(GetDlgItem(IDC_CHECK_SHELLMENU_COMPRESS),bActive);
	::EnableWindow(GetDlgItem(IDC_CHECK_SHELLMENU_EXTRACT),bActive);
	::EnableWindow(GetDlgItem(IDC_CHECK_SHELLMENU_LIST),bActive);
	::EnableWindow(GetDlgItem(IDC_CHECK_SHELLMENU_TEST),bActive);
	::EnableWindow(GetDlgItem(IDC_CHECK_SHELLMENU_UNDER_SUBMENU),bActive);

	::EnableWindow(GetDlgItem(IDC_CHECK_DRAGMENU_COMPRESS),bActive);
	::EnableWindow(GetDlgItem(IDC_CHECK_DRAGMENU_EXTRACT),bActive);
	::EnableWindow(GetDlgItem(IDC_CHECK_DRAGMENU_UNDER_SUBMENU),bActive);

	//------------------------------------
	// 펞gj[gp邩ǂ
	//------------------------------------
	::EnableWindow(GetDlgItem(IDC_CHECK_SHELL_EXT_FORCE_EXTRA),bActive);

	//j[JX^}CY
	bActive=bActive&&(!Check_ShellExtForceExtra.GetCheck());
	::EnableWindow(GetDlgItem(IDC_CHECK_SHELL_EXT_USECUSTOM),bActive);
	::EnableWindow(GetDlgItem(IDC_BUTTON_EDIT_SHELLMENU),bActive);

	return TRUE;
}

LRESULT CConfigShellExt::OnApply()
{
//==========================
// VFgON/OFF𔽉f
//==========================
	bool CurrentShellExtStatus=(0!=Check_ShellExt.GetCheck());
	if(CurrentShellExtStatus!=DefaultShellExtStatus){
		if(CurrentShellExtStatus){
			if(!ShellRegisterServer(m_hWnd,_T("ShellExtDLL.dll")))return FALSE;
		}
		else{
			if(!ShellUnregisterServer(m_hWnd,_T("ShellExtDLL.dll")))return FALSE;
		}
	}

//===============================
// ݒConfigManagerɏ߂
//===============================
	//---------------
	// DDXf[^XV
	//---------------
	if(!DoDataExchange(TRUE)){
		return FALSE;
	}
	return TRUE;
}


LRESULT CConfigShellExt::OnShellExt(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		BOOL bActive=Check_ShellExt.GetCheck();
		::EnableWindow(GetDlgItem(IDC_CHECK_SHELLMENU_COMPRESS),bActive);
		::EnableWindow(GetDlgItem(IDC_CHECK_SHELLMENU_EXTRACT),bActive);
		::EnableWindow(GetDlgItem(IDC_CHECK_SHELLMENU_LIST),bActive);
		::EnableWindow(GetDlgItem(IDC_CHECK_SHELLMENU_TEST),bActive);
		::EnableWindow(GetDlgItem(IDC_CHECK_SHELLMENU_UNDER_SUBMENU),bActive);

		::EnableWindow(GetDlgItem(IDC_CHECK_DRAGMENU_COMPRESS),bActive);
		::EnableWindow(GetDlgItem(IDC_CHECK_DRAGMENU_EXTRACT),bActive);
		::EnableWindow(GetDlgItem(IDC_CHECK_DRAGMENU_UNDER_SUBMENU),bActive);

		::EnableWindow(GetDlgItem(IDC_CHECK_SHELL_EXT_FORCE_EXTRA),bActive);


		//j[JX^}CY
		bActive=bActive&&(!Check_ShellExtForceExtra.GetCheck());
		::EnableWindow(GetDlgItem(IDC_CHECK_SHELL_EXT_USECUSTOM),bActive);
		::EnableWindow(GetDlgItem(IDC_BUTTON_EDIT_SHELLMENU),bActive);
	}
	return 0;
}

LRESULT CConfigShellExt::OnShellExtForceExtra(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		BOOL bActive=(!Check_ShellExtForceExtra.GetCheck())&&Check_ShellExt.GetCheck();
		::EnableWindow(GetDlgItem(IDC_CHECK_SHELL_EXT_USECUSTOM),bActive);
		::EnableWindow(GetDlgItem(IDC_BUTTON_EDIT_SHELLMENU),bActive);
	}
	return 0;
}

LRESULT CConfigShellExt::OnEditMenu(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED!=wNotifyCode){
		return 0;
	}

	//ҏWvON
	TCHAR szPath[_MAX_PATH]={0};
	GetModuleFileName(NULL,szPath,_MAX_PATH);

	PathRemoveFileSpec(szPath);
	PathAppend(szPath,_T("MenuEditor.exe"));

	ShellExecute(m_hWnd,_T("open"),szPath,NULL,NULL,SW_SHOW);
	return 0;
}
