#pragma once
#include "config.h"
#include "../resource.h"
#include <atlddx.h>		// DDX/DDVgp邽

//====================================
// ʐݒ荀
//====================================
class CConfigShellExt : public CDialogImpl<CConfigShellExt>,public CMessageFilter,public CWinDataExchange<CConfigShellExt>
{
protected:
	bool DefaultShellExtStatus;
	CButton Check_ShellExt;
	CButton Check_ShellExtForceExtra;
	CConfigManager	&Config;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnShellExt(WORD,WORD,HWND,BOOL&);
	LRESULT OnShellExtForceExtra(WORD,WORD,HWND,BOOL&);
	LRESULT OnEditMenu(WORD,WORD,HWND,BOOL&);
public:
	enum { IDD = IDD_PROPPAGE_CONFIG_SHELLEXT };
	// DDX}bv
	BEGIN_DDX_MAP(CConfigShellExt)
		DDX_CHECK(IDC_CHECK_SHELLMENU_COMPRESS,Config.ShellExt.ShellMenuCompress)
		DDX_CHECK(IDC_CHECK_SHELLMENU_EXTRACT,Config.ShellExt.ShellMenuExtract)
		DDX_CHECK(IDC_CHECK_SHELLMENU_LIST,Config.ShellExt.ShellMenuList)
		DDX_CHECK(IDC_CHECK_SHELLMENU_TEST,Config.ShellExt.ShellMenuTest)
		DDX_CHECK(IDC_CHECK_SHELLMENU_UNDER_SUBMENU,Config.ShellExt.ShellMenuUnderSubMenu)

		DDX_CHECK(IDC_CHECK_DRAGMENU_COMPRESS,Config.ShellExt.DragMenuCompress)
		DDX_CHECK(IDC_CHECK_DRAGMENU_EXTRACT,Config.ShellExt.DragMenuExtract)
		DDX_CHECK(IDC_CHECK_DRAGMENU_UNDER_SUBMENU,Config.ShellExt.DragMenuUnderSubMenu)

		DDX_CHECK(IDC_CHECK_SHELL_EXT_FORCE_EXTRA,Config.ShellExt.ForceExtraMenu)
		DDX_CHECK(IDC_CHECK_SHELL_EXT_USECUSTOM,Config.ShellExt.UseCustomMenu)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigShellExt)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_BUTTON_EDIT_SHELLMENU,OnEditMenu)
		COMMAND_ID_HANDLER(IDC_CHECK_SHELL_EXT,OnShellExt)
		COMMAND_ID_HANDLER(IDC_CHECK_SHELL_EXT_FORCE_EXTRA,OnShellExtForceExtra)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnApply();

	CConfigShellExt(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE("CConfigShellExt()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

};

