#pragma once

#include "config.h"
#include "../resource.h"

//====================================
// TAR̐ݒ荀
//====================================
class CConfigTAR : public CDialogImpl<CConfigTAR>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	CEdit			Edit_GZIP_Level;
	CTrackBarCtrl	Track_GZIP_Level;

	CEdit			Edit_BZIP2_Level;
	CTrackBarCtrl	Track_BZIP2_Level;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}
public:
	enum { IDD = IDD_PROPPAGE_CONFIG_TAR };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigTAR)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_HSCROLL(OnHScroll)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	void OnHScroll(int, short, HWND);

	CConfigTAR(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE("CConfigTAR()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

