#pragma once
#include "../common.h"
#include <atlctrlx.h> //hyperlink
#include "../resource.h"
#include "../util.h"

//====================================
// o[W
//====================================
class CConfigVersion : public CDialogImpl<CConfigVersion>,public CMessageFilter
{
protected:
	CHyperLink link_url;
	CHyperLink link_mailto;
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_VERSION };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigVersion)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);

	CConfigVersion()
	{
		TRACE("CConfigVersion()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

