#pragma once

#include "config.h"
#include "../resource.h"
#include <atlddx.h>		// DDX/DDVgp邽

//====================================
// XACRETT̐ݒ荀
//====================================
class CConfigXACRETT : public CDialogImpl<CConfigXACRETT>,public CWinDataExchange<CConfigXACRETT>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	CButton Check_EnableXacrett;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_XACRETT };

	// DDX}bv
	BEGIN_DDX_MAP(CConfigXACRETT)
		DDX_TEXT(IDC_EDIT_XACRETT_PRIORITY_EXTENSION, Config.XACRETT.Extensions)
		DDX_CHECK(IDC_CHECK_ENABLE_XACRETT_MENU, Config.XACRETT.EnableShellMenu)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigXACRETT)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_CHECK_ENABLE_XACRETT,OnCheckEnableXacrett)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	LRESULT OnCheckEnableXacrett(WORD,WORD,HWND,BOOL&);

	CConfigXACRETT(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE("CConfigXACRETT()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

