#pragma once
#include "../common.h"
#include "dirtree.h"
#include <map>

class CFileTreeView:public CWindowImpl<CFileTreeView,CTreeViewCtrl>
{
protected:
	CImageList	ImageList;
	BEGIN_MSG_MAP_EX(CFileTreeView)
		MSG_WM_CREATE(OnCreate)
		MSG_WM_DESTROY(OnDestroy)
//		DEFAULT_REFLECTION_HANDLER()
	END_MSG_MAP()

	LRESULT OnCreate(LPCREATESTRUCT lpcs);
	LRESULT OnDestroy();

	std::map<CDirectoryTree*,HTREEITEM>ItemMap;
public:
	DECLARE_WND_SUPERCLASS(NULL, CTreeViewCtrl::GetWndClassName())
	BOOL PreTranslateMessage(MSG* pMsg){return FALSE;}

	bool MakeTree(CDirectoryTree*,HTREEITEM,bool,FILELISTMODE FileListMode);
	bool SetCurrentNode(CDirectoryTree*);
	void Clear();
};
