#include "stdafx.h"
#include "MenuData.h"
#include "ConfigManager.h"
#include "main.h"
#include <Lmcons.h>
#include "lfutil.h"

void CConfigManager::LoadConfig(BOOL bRightDrag,BOOL bForceExtra)
{
	//ϐ
	ZeroMemory(&ShellMenu,sizeof(ShellMenu));
	ZeroMemory(&DragMenu,sizeof(DragMenu));
	bUnderSubMenu=false;

	// pXɂINĨtpXgݗ
	char thePath[_MAX_PATH+1]={0};
	::GetModuleFileName(g_hInstDLL, thePath, sizeof(thePath));	//DLL̃pX擾
	PathRemoveFileSpec(thePath);
	//---[U[ԋʐݒp邩`FbN
	TCHAR szUserCommon[_MAX_PATH+1]={0};
	_tcsncpy(szUserCommon,thePath,_MAX_PATH);
	PathAppend(szUserCommon,_T("LhaForge.ini"));
	if(PathFileExists(szUserCommon)){
		//ʐݒ
		_tcsncpy(thePath,szUserCommon,_MAX_PATH);
	}
	else{
		//INĨt@CgݗĂ
		TCHAR UserName[UNLEN+1]={0};

		DWORD Length=UNLEN;
		GetUserName(UserName,&Length);
		PathAppend(thePath,UserName);
		PathAddBackslash(thePath);
		PathAppend(thePath,_T("LhaForge.ini"));
	}

	dprintf("Common-> IniPath=%s\n",thePath);

//---------------------------------------------------
	//펞gj[𗘗p邩ǂ
	if(bForceExtra){
		bExtraMenu=TRUE;
	}
	else{
		bExtraMenu=GetPrivateProfileInt("ExtraMenu","ForceExtraMenu",0,thePath);
	}

	if(bRightDrag){
		//--------------------
		// EhbOj[
		//--------------------

		//k
		DragMenu.bCompress=GetPrivateProfileInt("DragMenu","Compress",1,thePath);
		//k
		DragMenu.bExtract=GetPrivateProfileInt("DragMenu","Extract",1,thePath);
		//------------------------------
		// Tuj[ȉɕ荞ށH
		//------------------------------
		//LE
		bUnderSubMenu=GetPrivateProfileInt("DragMenu","UnderSubMenu",0,thePath);
	}
	else{
		//--------------------
		// ENbNj[
		//--------------------
		//k
		ShellMenu.bCompress=GetPrivateProfileInt("ShellMenu","Compress",1,thePath);
		//
		ShellMenu.bExtract=GetPrivateProfileInt("ShellMenu","Extract",1,thePath);
		//{
		ShellMenu.bList=GetPrivateProfileInt("ShellMenu","List",1,thePath);
		//Ɍ
		ShellMenu.bTestArchive=GetPrivateProfileInt("ShellMenu","Test",1,thePath);
		//------------------------------
		// Tuj[ȉɕ荞ށH
		//------------------------------
		//LE
		bUnderSubMenu=GetPrivateProfileInt("ShellMenu","UnderSubMenu",0,thePath);
	}

	if(!bExtraMenu&&(ShellMenu.bCompress||DragMenu.bCompress)){
		//JX^j[
		bCustomCompress=GetPrivateProfileInt("CustomMenu","UseCustom",0,thePath);
		if(bCustomCompress){	//JX^}CYꂽj[g
			GetPrivateProfileString("CustomMenu","Arrange",USER_MENU_DEFAULT,szCustomCompress,_MAX_PATH,thePath);
		}
	}

	//-----------------
	// XacRettj[
	//-----------------
	//LE
	bXacRett=GetPrivateProfileInt("XacRett","EnableShellMenu",0,thePath);
	//-----------------
	// B2Ej[
	//-----------------
	//LE
	bB2E=GetPrivateProfileInt("B2E","EnableShellMenu",0,thePath);

	//----------------------
	// [U[`j[
	//----------------------
	//LE
	UserMenuArray.clear();
	UINT iIndex=0;
	for(;;iIndex++){
		CString strSectionName;
		strSectionName.Format(_T("UserMenu%d"),iIndex);
		if(!UtilCheckINISectionExists(strSectionName,thePath)){
			break;
		}
		CUserMenuItem umi={0};
		//LvV
		GetPrivateProfileString(strSectionName,_T("Caption"),strSectionName,umi.Caption,COUNTOF(umi.Caption)-1,thePath);
		//p[^
		GetPrivateProfileString(strSectionName,_T("Param"),_T(""),umi.Param,COUNTOF(umi.Param)-1,thePath);
		//ENbNŕ\?
		umi.bShellMenu=GetPrivateProfileInt(strSectionName,_T("ShellMenu"),TRUE,thePath);
		//EhbOŕ\H
		umi.bDragMenu=GetPrivateProfileInt(strSectionName,_T("DragMenu"),TRUE,thePath);
		//\\鎞[h
		if(umi.bShellMenu||umi.bDragMenu){
			UserMenuArray.push_back(umi);
		}
	}
}
