#pragma once
#include "resource.h"

//#define OUTPUTDIR_DEFAULT		">?*DEFAULT*"	//ʏ̏ꏊɉ
#define OUTPUTDIR_DESKTOP		">?*DESKTOP*"	//fXNgbvɉ
#define OUTPUTDIR_SAMEDIR		">?*SAMEDIR*"	//ꏊɉ
#define OUTPUTDIR_SPECIFIED		">?*SPECIFIED*"	//wꏊɉ
//#define OUTPUTDIR_HERE		">?*HERE*"		//ɉ

//LvVLhaForgȅp[^
struct SHELL_MENU_ITEM{
	WORD Caption;
	LPCTSTR Param;
};

struct CUserMenuItem{	//[U[`j[̍ڒ`
	TCHAR	Caption[_MAX_PATH+1];
	TCHAR	Param[_MAX_PATH+1];
	BOOL	bShellMenu;		//ENbNj[ŕ\
	BOOL	bDragMenu;		//EhbOj[ŕ\
};


//kj[
const SHELL_MENU_ITEM CompressMenu[]={
	{IDS_MENU_ITEM_CAPTION_LZH,"/c:lzh"},
	{IDS_MENU_ITEM_CAPTION_ZIP,"/c:zip"},
	{IDS_MENU_ITEM_CAPTION_CAB,"/c:cab"},
	{IDS_MENU_ITEM_CAPTION_7Z,"/c:7z"},
	{IDS_MENU_ITEM_CAPTION_TAR,"/c:tar"},
	{IDS_MENU_ITEM_CAPTION_GZ,"/c:gz"},
	{IDS_MENU_ITEM_CAPTION_BZ2,"/c:bz2"},
	{IDS_MENU_ITEM_CAPTION_TGZ,"/c:tgz"},
	{IDS_MENU_ITEM_CAPTION_TBZ,"/c:tbz"},
	{IDS_MENU_ITEM_CAPTION_JACK,"/c:jak"},
	{IDS_MENU_ITEM_CAPTION_YZ1,"/c:yz1"},
	{IDS_MENU_ITEM_CAPTION_HKI,"/c:hki"},
	{IDS_MENU_ITEM_CAPTION_BZA,"/c:bza"},
	{IDS_MENU_ITEM_CAPTION_GZA,"/c:gza"},
	{IDS_MENU_ITEM_CAPTION_ISH,"/c:ish"},
	{IDS_MENU_ITEM_CAPTION_UUE,"/c:uue"},
	{IDS_MENU_ITEM_CAPTION_COMPRESS_B2E,"/b2e /c"},
};
const int MAX_COMPRESS_MENU=COUNTOF(CompressMenu);

//Wkj[
const SHELL_MENU_ITEM
	ExtraMenuLZH[]={
		{IDS_MENU_ITEM_CAPTION_LZH,NULL},
		{IDS_MENU_ITEM_CAPTION_LZH,"/c:lzh"},
		{IDS_MENU_ITEM_CAPTION_LZH_SFX,"/c:lzhsfx"}
	},
	ExtraMenuZIP[]={
		{IDS_MENU_ITEM_CAPTION_ZIP,NULL},
		{IDS_MENU_ITEM_CAPTION_ZIP,"/c:zip"},
		{IDS_MENU_ITEM_CAPTION_ZIP_PASS,"/c:zippass"},
		{IDS_MENU_ITEM_CAPTION_ZIP_SFX,"/c:zipsfx"},
		{IDS_MENU_ITEM_CAPTION_ZIP_PASS_SFX,"/c:zippasssfx"},
		{IDS_MENU_ITEM_CAPTION_ZIP_SPLIT,"/c:zipsplit"},
		{IDS_MENU_ITEM_CAPTION_ZIP_PASS_SPLIT,"/c:zippasssplit"}
	},
	ExtraMenuCAB[]={
		{IDS_MENU_ITEM_CAPTION_CAB,NULL},
		{IDS_MENU_ITEM_CAPTION_CAB,"/c:cab"},
		{IDS_MENU_ITEM_CAPTION_CAB_SFX,"/c:cabsfx"}
	},
	ExtraMenu7Z[]={
		{IDS_MENU_ITEM_CAPTION_7Z,NULL},
		{IDS_MENU_ITEM_CAPTION_7Z,"/c:7z"},
		{IDS_MENU_ITEM_CAPTION_7Z_PASS,"/c:7zpass"},
		{IDS_MENU_ITEM_CAPTION_7Z_SFX,"/c:7zsfx"},
		{IDS_MENU_ITEM_CAPTION_7Z_SPLIT,"/c:7zsplit"},
		{IDS_MENU_ITEM_CAPTION_7Z_PASS_SPLIT,"/c:7zpasssplit"}
	},
	ExtraMenuTAR[]={
		{IDS_MENU_ITEM_CAPTION_TAR_RELATED,NULL},
		{IDS_MENU_ITEM_CAPTION_TAR,"/c:tar"},
		{IDS_MENU_ITEM_CAPTION_GZ,"/c:gz"},
		{IDS_MENU_ITEM_CAPTION_BZ2,"/c:bz2"},
		{IDS_MENU_ITEM_CAPTION_TGZ,"/c:tgz"},
		{IDS_MENU_ITEM_CAPTION_TBZ,"/c:tbz"}
	},
	ExtraMenuJACK[]={
		{IDS_MENU_ITEM_CAPTION_JACK,NULL},
		{IDS_MENU_ITEM_CAPTION_JACK,"/c:jak"},
		{IDS_MENU_ITEM_CAPTION_JACK_SFX,"/c:jaksfx"}
	},
	ExtraMenuYZ1[]={
		{IDS_MENU_ITEM_CAPTION_YZ1,NULL},
		{IDS_MENU_ITEM_CAPTION_YZ1,"/c:yz1"},
		{IDS_MENU_ITEM_CAPTION_YZ1_PASS,"/c:yz1pass"},
		{IDS_MENU_ITEM_CAPTION_YZ1_SFX,"/c:yz1sfx"},
		{IDS_MENU_ITEM_CAPTION_YZ1_PUB_PASS,"/c:yz1pubpass"},
		{IDS_MENU_ITEM_CAPTION_YZ1_PUB_PASS_SFX,"/c:yz1pubpasssfx"}
	},
	ExtraMenuHKI[]={
		{IDS_MENU_ITEM_CAPTION_HKI,NULL},
		{IDS_MENU_ITEM_CAPTION_HKI,"/c:hki"},
		{IDS_MENU_ITEM_CAPTION_HKI_PASS,"/c:hkipass"},
		{IDS_MENU_ITEM_CAPTION_HKI_SFX,"/c:hkisfx"},
	},
	ExtraMenuBGA[]={
		{IDS_MENU_ITEM_CAPTION_BGA,NULL},
		{IDS_MENU_ITEM_CAPTION_BZA,"/c:bza"},
		{IDS_MENU_ITEM_CAPTION_BZA_SFX,"/c:bzasfx"},
		{IDS_MENU_ITEM_CAPTION_GZA,"/c:gza"},
		{IDS_MENU_ITEM_CAPTION_GZA_SFX,"/c:gzasfx"}
	},
	ExtraMenuAISH[]={
		{IDS_MENU_ITEM_CAPTION_AISH,NULL},
		{IDS_MENU_ITEM_CAPTION_ISH,"/c:ish"},
		{IDS_MENU_ITEM_CAPTION_UUE,"/c:uue"}
	}
;

//𓀃j[
const SHELL_MENU_ITEM ExtractMenu[]={
	{IDS_MENU_CAPTION_EXTRACT_NORMAL,"/e"},
	{IDS_MENU_CAPTION_EXTRACT_DESKTOP,"/e /o:"OUTPUTDIR_DESKTOP},
	{IDS_MENU_CAPTION_EXTRACT_SAME,"/e /o:"OUTPUTDIR_SAMEDIR},
	{IDS_MENU_CAPTION_EXTRACT_TARGET,"/e /o:"OUTPUTDIR_SPECIFIED}
};
const int MAX_EXTRACT_MENU=COUNTOF(ExtractMenu);

//XacRettj[
const SHELL_MENU_ITEM XacRettMenu[]={
	{IDS_MENU_CAPTION_EXTRACT_NORMAL,"/xacrett /e"},
	{IDS_MENU_CAPTION_EXTRACT_DESKTOP,"/xacrett /e /o:"OUTPUTDIR_DESKTOP},
	{IDS_MENU_CAPTION_EXTRACT_SAME,"/xacrett /e /o:"OUTPUTDIR_SAMEDIR},
	{IDS_MENU_CAPTION_EXTRACT_TARGET,"/xacrett /e /o:"OUTPUTDIR_SPECIFIED},
	{IDS_MENU_CAPTION_LIST_XACRETT,"/xacrett /l"}
};
const int MAX_XACRETT_MENU=COUNTOF(XacRettMenu);

//B2Ej[
const SHELL_MENU_ITEM B2EMenu[]={
	{IDS_MENU_ITEM_CAPTION_COMPRESS_B2E,"/b2e /c"},
	{IDS_MENU_CAPTION_EXTRACT_NORMAL,"/b2e /e"},
	{IDS_MENU_CAPTION_EXTRACT_DESKTOP,"/b2e /e /o:"OUTPUTDIR_DESKTOP},
	{IDS_MENU_CAPTION_EXTRACT_SAME,"/b2e /e /o:"OUTPUTDIR_SAMEDIR},
	{IDS_MENU_CAPTION_EXTRACT_TARGET,"/b2e /e /o:"OUTPUTDIR_SPECIFIED},
	{IDS_MENU_CAPTION_LIST_XACRETT,"/b2e /l"}
};
const int MAX_B2E_MENU=COUNTOF(B2EMenu);

//B2E(Drag)j[
const SHELL_MENU_ITEM B2EDragMenu[]={
	{IDS_MENU_CAPTION_COMPRESS_DRAG,"/b2e /c"},
	{IDS_MENU_CAPTION_EXTRACT_DRAG,"/b2e /e"},
};
const int MAX_B2E_DRAG_MENU=COUNTOF(B2EDragMenu);
//-------------------------------------------------
//[U[ɂ鈳kj[JX^}CYpe[u

struct SHELL_MENU_ITEM_USER{
	TCHAR Identifier;				//j[ACeʕ
	const SHELL_MENU_ITEM *lpMenuItem;	//j[ACeւ̃|C^
};

const SHELL_MENU_ITEM_USER UserMenuTable[]={
	{_T('l'),&ExtraMenuLZH[1]},
	{_T('L'),&ExtraMenuLZH[2]},

	{_T('z'),&ExtraMenuZIP[1]},
	{_T('Z'),&ExtraMenuZIP[2]},
	{_T('s'),&ExtraMenuZIP[3]},
	{_T('S'),&ExtraMenuZIP[4]},
	{_T('p'),&ExtraMenuZIP[5]},
	{_T('P'),&ExtraMenuZIP[6]},

	{_T('c'),&ExtraMenuCAB[1]},
	{_T('C'),&ExtraMenuCAB[2]},

	{_T('7'),&ExtraMenu7Z[1]},
	{_T('6'),&ExtraMenu7Z[2]},
	{_T('5'),&ExtraMenu7Z[3]},
	{_T('4'),&ExtraMenu7Z[4]},
	{_T('3'),&ExtraMenu7Z[5]},

	{_T('t'),&ExtraMenuTAR[1]},
	{_T('q'),&ExtraMenuTAR[2]},
	{_T('Q'),&ExtraMenuTAR[3]},
	{_T('v'),&ExtraMenuTAR[4]},
	{_T('V'),&ExtraMenuTAR[5]},

	{_T('j'),&ExtraMenuJACK[1]},
	{_T('J'),&ExtraMenuJACK[2]},

	{_T('y'),&ExtraMenuYZ1[1]},
	{_T('Y'),&ExtraMenuYZ1[2]},
	{_T('x'),&ExtraMenuYZ1[3]},
	{_T('X'),&ExtraMenuYZ1[4]},
	{_T('1'),&ExtraMenuYZ1[5]},

	{_T('h'),&ExtraMenuHKI[1]},
	{_T('H'),&ExtraMenuHKI[2]},
	{_T('k'),&ExtraMenuHKI[3]},

	{_T('b'),&ExtraMenuBGA[1]},
	{_T('B'),&ExtraMenuBGA[2]},
	{_T('g'),&ExtraMenuBGA[3]},
	{_T('G'),&ExtraMenuBGA[4]},

	{_T('i'),&ExtraMenuAISH[1]},
	{_T('u'),&ExtraMenuAISH[2]},

	{_T('/'),&B2EMenu[0]},
};
const int MAX_USER_MENU_TABLE=COUNTOF(UserMenuTable);
const LPCTSTR USER_MENU_DEFAULT=_T("lzc7tqQvVjyhbgiu/");
